Cubature
--------

This is a simple C
package for **adaptive multidimensional integration** (*cubature*) of
**vector-valued integrands** over **hypercubes**, written by
[Steven G. Johnson](http://math.mit.edu/~stevenj).  That is, it computes
integrals of the form:

![n-dimensional integral](doc/integral.png)

(Of course, it can handle scalar integrands as the special case where
f is a one-dimensional vector: the dimensionalities of f
and x are independent.) The integrand can be evaluated for an
**array of points at once** to enable **easy parallelization**. The
code, which is distributed as **free software** under the terms of the
[GNU General Public License](w:GNU_General_Public_License "wikilink")
(v2 or later), implements two algorithms for adaptive integration.

The first, *h*-adaptive integration (recursively partitioning the
integration domain into smaller subdomains, applying the same
integration rule to each, until convergence is achieved), is based on
the algorithms described in:

-   A. C. Genz and A. A. Malik, “An adaptive algorithm for numeric
    integration over an N-dimensional rectangular region,” *J. Comput.
    Appl. Math.* **6** (4), 295–302 (1980).
-   J. Berntsen, T. O. Espelid, and A. Genz, “An adaptive algorithm for
    the approximate calculation of multiple integrals,” *ACM Trans.
    Math. Soft.* **17** (4), 437–451 (1991).

This algorithm is **best suited for a moderate number of dimensions**
(say, < 7), and is superseded for high-dimensional integrals by other
methods (e.g. [Monte Carlo](w:Monte_Carlo_integration "wikilink")
variants or [sparse grids](w:Sparse_grid "wikilink")).

(Note that we do *not* use any of the original DCUHRE code by Genz,
which is not under a free/open-source license.) Our code is based in
part on code borrowed from the [HIntLib numeric-integration
library](http://mint.sbg.ac.at/HIntLib/) by Rudolf Schürer and from code
for Gauss-Kronrod quadrature (for 1d integrals) from the [GNU Scientific
Library](http://www.gnu.org/software/gsl/), both of which are free
software under the GNU GPL. (Another free-software multi-dimensional
integration library, unrelated to our code here but also implementing
the Genz–Malik algorithm among other techniques, is
[Cuba](http://www.feynarts.de/cuba/).)

The second, *p*-adaptive integration (repeatedly doubling the degree of
the quadrature rules until convergence is achieved), is based on a
tensor product of [Clenshaw–Curtis quadrature](https://en.wikipedia.org/wiki/Clenshaw%E2%80%93Curtis_quadrature) rules. This
algorithm is often superior to *h*-adaptive integration for
[smooth](https://en.wikipedia.org/wiki/Smoothness) integrands in a few (≤ 3)
dimensions, but is a poor choice in higher dimensions or for non-smooth
integrands.

For the most part, the *p*-adaptive routines below are drop-in
replacements for the *h*-adaptive routines, with the same arguments
etcetera, so you can experiment to see which one works best for your
problem. One difference: the *h*-adaptive routines do *not* evaluate
the integrand on the boundaries of the integration volume, whereas the
*p*-adaptive routines *do* evaluate the integrand at the boundaries.
This means that the *p* adaptive routines require more care in cases
where there are singularities at the boundaries.

I am also grateful to Dmitry Turbiner (dturbiner ατ alum.mit.edu), who
implemented an initial prototype of the “vectorized” functionality (see
below) for evaluating an array of points in a single call, which
facilitates parallelization of the integrand evaluation.

Download
--------

The current version of the code can be downloaded from
[github repository](https://github.com/stevengj/cubature).

Either way, you get a directory containing stand-alone `hcubature.c` and `pcubature.c` files
(along with a couple of private header files) that you can compile and
link into your program for h-adaptive and p-adaptive integration,
respectively, and a header file `cubature.h` that you `#include`, as
described below.

The `test.c` file contains a little test program which is produced if
you compile that file with `-DHCUBATURE` or `-DPCUBATURE` and link with
`hcubature.c` or `pcubature.c`, respectively, as described below.

B. Narasimhan wrote a [GNU R](w:GNU_R "wikilink") interface, which can
be downloaded here:
[<http://cran.r-project.org/web/packages/cubature/index.html>](http://cran.r-project.org/web/packages/cubature/index.html).

A [Julia](http://julialang.org/) interface can be obtained from
[Cubature.jl](https://github.com/stevengj/Cubature.jl). A Python
[cubature.py interface](https://github.com/saullocastro/cubature)
written by Saullo Castro is also available.

Usage
-----

You should compile `hcubature.c` and/or `pcubature.c` and link it with
your program, and `#include` the header file `cubature.h`.

The central subroutine you will be calling for h-adaptive cubature is:

```c
int hcubature(unsigned fdim, integrand f, void *fdata,
              unsigned dim, const double *xmin, const double *xmax, 
              size_t maxEval, double reqAbsError, double reqRelError,
              error_norm norm,
              double *val, double *err);
```

or `pcubature` (same arguments) for p-adaptive cubature. (See also the
vectorized interface below.)

This integrates a function F(x), returning a vector of FDIM integrands,
where x is a DIM-dimensional vector ranging from XMIN to XMAX (i.e. in a
hypercube XMINᵢ ≤ xᵢ ≤ XMAXᵢ).

MAXEVAL specifies a maximum number of function evaluations (0 for no
limit). (Note: the actual number of evaluations may somewhat exceed
MAXEVAL: MAXEVAL is rounded up to an integer number of subregion
evaluations.) Otherwise, the integration stops when the estimated
|error| is less than REQABSERROR (the absolute error requested) **or**
when the estimated |error| is less than REQRELERROR × |integral value|
(the relative error requested). (Either of the error tolerances can be
set to **zero to ignore** it.)

For vector-valued integrands (FDIM > 1), NORM specifies the norm that
is used to measure the error and determine convergence properties. (The
NORM argument is irrelevant for FDIM ≤ 1 and is ignored.) Given vectors
*v* and *e* of estimated integrals and errors therein, respectively, the
NORM argument takes on one of the following enumerated constant values:

-   `ERROR_L1`, `ERROR_L2`, `ERROR_LINF`: the absolute error is measured
    as |e| and the relative error as |e|/|v|, where |...| is the
    [L₁](https://en.wikipedia.org/wiki/Taxicab_geometry),
    [L₂](https://en.wikipedia.org/wiki/Euclidean_distance), or
    [L∞](https://en.wikipedia.org/wiki/Uniform_norm)
    [norm](https://en.wikipedia.org/wiki/Norm_(mathematics)), respectively. (|x| in the
    L₁ norm is the sum of the absolute values of the components, in
    the L₂ norm is the root mean square of the components, and in the
    L∞ norm is the maximum absolute value of the components)

-   `ERROR_INDIVIDUAL`: Convergence is achieved only when each integrand
    (each component of v and e) individually satisfies the requested
    error tolerances.

-   `ERROR_PAIRED`: Like `ERROR_INDIVIDUAL`, except that the integrands
    are grouped into consecutive pairs, with the error tolerance applied
    in an L₂ sense to each pair. This option is mainly useful for
    integrating vectors of complex numbers, where each consecutive pair
    of real integrands is the real and imaginary parts of a single complex
    integrand, and you only care about the error in the complex plane rather
    than the error in the real and imaginary parts separately.

`VAL` and `ERR` are arrays of length `FDIM`, which upon return are the
computed integral values and estimated errors, respectively. (The
estimated errors are based on an embedded cubature rule of lower order;
for smooth functions, this estimate is usually conservative.)

The return value of `hcubature` and `pcubature` is 0 on success and
nonzero if there was an error (mainly only out-of-memory situations or
if the integrand signals an error). For a nonzero return value, the
contents of the `VAL` and `ERR` arrays are undefined.

The integrand function `F` should be a function of the form:

```c
int f(unsigned ndim, const double *x, void *fdata,
      unsigned fdim, double *fval);
```

Here, the input is an array `X` of length `NDIM` (the point to be
evaluated), the output is an array `FVAL` of length `FDIM` (the vector
of function values at the point `X`). he return value should be 0 on
success or a nonzero value if an error occurred and the integration is
to be terminated immediately (`hcubature` will then return a nonzero
error code).

The `FDATA` argument of `F` is equal to the `FDATA` argument passed to
`hcubature`—this can be used by the caller to pass any additional
information through to `F` as needed (rather than using global
variables, which are not re-entrant). If `F` does not need any
additional data, you can just pass `FDATA` = `NULL` and ignore the
`FDATA` argument to `F`.

### “Vectorized” interface

These integration algorithms actually evaluate the integrand in
“batches” of several points at a time. It is often useful to have access
to this information so that your integrand function is not called for
one point at a time, but rather for a whole “vector” of many points at
once. For example, you may want to evaluate the integrand in parallel at
different points. This functionality is available by calling:

```c
int hcubature_v(unsigned fdim, integrand_v f, void *fdata,
                unsigned dim, const double *xmin, const double *xmax,
                unsigned maxEval, double reqAbsError, double reqRelError,
                error_norm norm, double *val, double *err);
```

(and similarly for `pcubature_v`). All of the arguments and the return
value are identical to `hcubature`, above, except that now the integrand
`F` is of type `integrand_v`, corresponding to a function of a different
form. The integrand function `F` should now be a function of the form:

```c
int f(unsigned ndim, unsigned npts, const double *x, void *fdata,
      unsigned fdim, double *fval);
```

Now, `X` is not a single point, but an array of `NPTS` points (length
`NPTS`×`NDIM`), and upon return the values of all `FDIM` integrands at
all `NPTS` points should be stored in `FVAL` (length `NPTS`×`FDIM`). In
particular, `x[i*ndim + j]` is the `j`-th coordinate of the `i`-th point
(`i<npts` and `j<ndim`), and the `k`-th function evaluation
(`k<fdim`) for the `i`-th point is returned in `fval[i*fdim + k]`.
(**Note**: the `fval` indexing is changed compared to the
`adapt_integrate_v` interface in previous versions.)

Again, the return value should be `0` on success or nonzero to terminate
the integration immediately (e.g. if an error occurred).

The size of `NPTS` will vary with the dimensionality of the problem;
higher-dimensional problems will have (exponentially) larger NPTS,
allowing for the possibility of more parallelism. Currently, for
`hcubature_v`, `NPTS` starts at 15 in 1d, 17 in 2d, and 33 in 3d, but as
`adapt_integrate_v` calls your integrand more and more times the value
of NPTS will grow. e.g. if you end up requiring several thousand points
in total, `NPTS` may grow to several hundred. We utilize an algorithm
from:

-   I. Gladwell, “Vectorization of one dimensional quadrature codes,”
    pp. 230–238 in *Numerical Integration. Recent Developments, Software
    and Applications*, G. Fairweather and P. M. Keast, eds., NATO ASI
    Series C203, Dordrecht (1987).

as described in the article “Parallel globally adaptive algorithms for
multi-dimensional integration” by [Bull and
Freeman](http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.42.6638)
(1994).

### Example

As a simple example, consider the Gaussian integral of the scalar
function f(x) = exp(-sigma |x|²) over the hypercube
[-2,2]³ in 3 dimensions. You could compute this integral via code
that looks like:

```c
#include <stdio.h>
#include <math.h>
#include "cubature.h"

int f(unsigned ndim, const double *x, void *fdata, unsigned fdim, double *fval) {
    double sigma = *((double *) fdata); // we can pass σ via fdata argument
    double sum = 0;
    unsigned i;
    for (i = 0; i < ndim; ++i) sum += x[i] * x[i];
    // compute the output value: note that fdim should == 1 from below
    fval[0] = exp(-sigma * sum);
    return 0; // success*
}
```

then, later in the program where we call `hcubature`:

```c
double xmin[3] = {-2,-2,-2}, xmax[3] = {2,2,2}, sigma = 0.5, val, err;
hcubature(1, f, &sigma, 3, xmin, xmax, 0, 0, 1e-4, ERROR_INDIVIDUAL, &val, &err);
printf("Computed integral = %0.10g +/- %g\n", val, err);
```

Here, we have specified a relative error tolerance of $10^{-4}$ (and no
absolute error tolerance or maximum number of function evaluations).
Note also that, to demonstrate the `fdata` parameter, we have used it to
pass the σ value through to our function (rather than hard-coding the
value of σ in `f` or using a global variable).

The output should be:

    Computed integral = 13.69609043 +/- 0.00136919

Note that the estimated *relative* error is 0.00136919/13.69609043 =
9.9969×10⁻⁵, within our requested tolerance of 10⁻⁴. The *actual*
error in the integral value, as can be determined e.g. by running the
integration with a much lower tolerance, is much smaller: the integral
is too small by about 0.00002, for an actual relative error of about
1.4×10⁻⁶. As mentioned above, for smooth integrands the estimated
error is almost always conservative (which means, unfortunately, that
the integrator usually does more function evaluations than it needs to).

With the vectorized interface `hcubature_v`, one would instead use:

```c
int f(unsigned ndim, unsigned npts, const double *x, void *fdata, unsigned fdim, double *fval) {
    double sigma = *((double *) fdata);
    unsigned i, j;
    for (j = 0; j < npts; ++j) { // evaluate the integrand for npts points
        double sum = 0;
        for (i = 0; i < ndim; ++i) sum += x[j*ndim+i] * x[j*ndim+i];
        fval[j] = exp(-sigma * sum);
    }
    return 0; // success
}
```

### Infinite intervals

Integrals over infinite or semi-infinite intervals is possible by a
[change of variables](w:Integration_by_substitution "wikilink"). This is
best illustrated in one dimension.

To compute an integral over a semi-infinite interval, you can perform
the change of variables x=a+t/(1-t):

![semi-infinite integral](doc/semi-infinite.png)

For an infinite interval, you can perform the change of variables
x=t/(1-t²):

![infinite integral](doc/infinite.png)

Note the [Jacobian](w:Jacobian_matrix "wikilink") factors multiplying
*f*(⋅⋅⋅) in both integrals, and also that the limits of the *t*
integrals are different in the two cases.

In multiple dimensions, one simply performs this change of variables on
each dimension separately, as desired, multiplying the integrand by the
corresponding Jacobian factor for each dimension being transformed.

The Jacobian factors diverge as the endpoints are approached. However,
if f(x) goes to zero at least as fast as 1/x², then the limit of
the integrand (including the Jacobian factor) is finite at the
endpoints. If your f(x) vanishes more slowly than 1/x² but still
faster than 1/x, then the integrand blows up at the endpoints but the
integral is still finite (it is an integrable singularity), so the code
will work (although it may take many function evaluations to converge).
If your f(x) vanishes only as 1/x, then it is not [absolutely convergent](https://en.wikipedia.org/wiki/Absolute_convergence) and much more care is
required even to define what you are trying to compute. (In any case,
the h-adaptive quadrature/cubature rules currently employed in
`cubature.c` do not evaluate the integrand at the endpoints, so you need
not implement special handling for |t|=1.)

Test program
------------

To compile a test programs, just compile `hcubature.c` and/or
`pcubature.c` along with the test program `test.c`, e.g. (on Unix or
GNU/Linux) via:

```
cc -o htest test.c hcubature.c -l
cc -o ptest -DPCUBATURE test.c pcubature.c -lm
```

The usage is then:

    ./htest <dim> <tol> <integrand> <maxeval>

where `<dim>` = #dimensions, `<tol>` = relative tolerance, `<integrand>` is
0–7 for one of eight possible test integrands (see below) and `<maxeval>`
is the maximum number of function evaluations (0 for none, the default).
Similarly for `ptest` (which tests the `pcubature` function).

The different test integrands are:

-   0: a product of cosine functions
-   1: a Gaussian integral of exp(-x²), remapped to [0,∞) limits
-   2: volume of a hypersphere (integrating a discontinuous function!)
-   3: a simple polynomial (product of coordinates)
-   4: a Gaussian centered in the middle of the integration volume
-   5: a sum of two Gaussians
-   6: an example function by Tsuda, a product of terms with near poles
-   7: a test integrand by Morokoff and Caflisch, a simple product of
    `dim`-th roots of the coordinates (weakly singular at the boundary)

For example:

    ./htest 3 1e-5 4

integrates the Gaussian function (4) to a desired relative error
tolerance of 10^–5^ in 3 dimensions. The output is:

```
3-dim integral, tolerance = 1e-05
integrand 4: integral = 1, est err = 9.99952e-06, true err = 2.54397e-08
#evals = 82203
```

Notice that it finds the integral after 82203 function evaluations with
an estimated error of about 10⁻⁵, but the true error (compared to the
exact result) is much smaller (2.5×10⁻⁸): the error estimation is
typically conservative when applied to smooth functions like this.

# Jscatter

The notebook directory contains some introductory files similar to the 
BeginnersGuide in the HTML documentation.

- Jscatter_Introduction.ipynb
- Jscatter_ReadData.ipynb
- Jscatter_BuildModels.ipynb
- Jscatter_Fitting.ipynb
- Jscatter_Lattice.ipynb
- Jscatter_Template.ipynb     
- Jscatter_Jupyterinstallation.ipynb

The main content about existing models and all options of specific commands
is found at [Jscatter](https://jscatter.readthedocs.io/en/latest/index.html)
including installation instructions.

Jupyter is a nice tool for demonstration, first learning and fast running evaluations. 
For strong usage with models that may take some time for calculation 
and fitting it is easier to use a command shell on Linux/OSX or even Windows. 
The shell can be put into background or on a cluster you can 
detach a shell running screen to later reconnect (there should be no graphical output).

For Jupyter the needed matplotlib is somehow slow that 
during the fit not updated output is possible (but works).

The notebooks contain a header section that installs Jscatter on a read only server.
If you run the notebooks on your local computer Jscatter may be installed
once as explained in one notebook. 
Then you need only to import Jscatter and NumPy.

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2020-2021  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

module dynamic
    use typesandconstants
    use utils
    !$ use omp_lib
    implicit none

contains

    function bnmt(t, NN, l, mu, modeamplist, tp, fixedends)
        ! Rouse/Zimm mode summation in Bnm with [coherent.., incoherent.., modeamplitudes..]

        ! times, mu, modeamplitudes, relaxation times, bond length
        real(dp), intent(in) :: t(:), mu, modeamplist(:), tp(:), l
        ! number beads, fixedends of chain
        integer, intent(in)  :: NN, fixedends
        ! result (n*m,tcoh + tinc + mode amplitudes (as t_inf))
        real(dp)             :: bnmt(NN*NN, 2*size(t) + size(modeamplist))
        ! internal stuff, mode numbers p, monomers n,m
        integer              :: p, n, m
        ! mode contributions
        real(dp)             :: pnm

        ! init
        bnmt = 0_dp

        !$omp parallel do
        do m = 1, NN
            do n = 1, NN
                do p = 1, size(modeamplist)
                    if (fixedends == 2) then
                        ! two fixed ends
                         pnm = modeamplist(p) * sin(pi_dp * p * n / NN) * sin(pi_dp * p * m / NN)
                    else if (fixedends == 1) then
                        ! one fixed end, one free
                         pnm = modeamplist(p) * sin(pi_dp * (p-0.5) * n / NN) * sin(pi_dp * (p-0.5) * m / NN)
                    else
                        ! two open ends as default , standeard ZIMM
                        pnm = modeamplist(p) * cos(pi_dp * p * n / NN) * cos(pi_dp * p * m / NN)
                    end if

                    ! coherent part
                    bnmt((n-1)*NN+m,:size(t)) = bnmt((n-1)*NN+m,:size(t)) + pnm * (1 - exp(-t/tp(p)))

                    ! each p for mode amplitudes and later infinite time is sum_p( mode amplitudes)
                    bnmt((n-1)*NN+m,2*size(t)+p) = bnmt((n-1)*NN+m,2*size(t)+p) + pnm

                    if (n == m) then
                        ! incoherent part
                        bnmt((n-1)*NN+m,size(t):2*size(t)) = bnmt((n-1)*NN+m,size(t):2*size(t)) + pnm * (1-exp(-t/tp(p)))
                    end if
                end do
                bnmt((n-1)*NN+m,:) = bnmt((n-1)*NN+m,:) + (abs(n - m) ** (2 * mu) * l ** 2)
            end do
        end do
        !$omp end parallel do

    end function bnmt

    function fourierw2t(w, s, ds, t) result(fft)
        ! fourier transform freq domain data to time domain
        ! do explicit not FFT to allow non-equidistant data
        ! The instrument resolution works like a window function
        ! inspired by unift from Reiner Zorn

        ! w frequency 1/ns, measured S(w) , error of S(w)
        real(dp), intent(in) :: w(:), s(:), ds(:)
        ! times in ns
        real(dp), intent(in) :: t(:)
        ! result times x 5 = [times, S(t), error S(t), real S(t), imag S(t)]
        real(dp)             :: fft(size(t), 5)
        integer :: i

        !$omp parallel do
        DO i = 1, size(t)
            ! returns [times, S(t), error S(t), real S(t), imag S(t)]
            fft(i,:) = fourier(w, s, ds, t(i))
        END DO
        !$omp end parallel do

    end function fourierw2t

    function fourier(w, s, ds, t) result(fft)
        ! explicit fourier transform for one timepoint
        ! w frequency 1/ns, measured S(w) , error of S(w)
        ! inspired by unift from Reiner Zorn
        real(dp), intent(in) :: w(:), s(:), ds(:)
        ! time ns
        real(dp), intent(in) :: t
        ! size of w,s,ds
        integer :: n
        ! amplitudes internal
        real(dp) :: a1(size(w)), a2(size(w)), swt(size(w)), cwt(size(w)), dft2(size(w)), t2
        ! result [t, ft, dft, real ft, imag ft]
        real(dp)       :: fft(5), ft, dft, ft1, ft2

        n = size(w)
        if (t /= 0_dp) then
            swt = sin(w * t)
            cwt = cos(w * t)
            t2 = one_dp / (t*t)

            a1(1) = -swt(1)/t + (cwt(1)-cwt(2))/(w(2)-w(1)) * t2
            a2(1) =  cwt(1)/t + (swt(1)-swt(2))/(w(2)-w(1)) * t2
            ! do i=2,n-1
            !   a1(i)=((cwt(i)-cwt(i+1))/(w(i+1)-w(i)) + (cwt(i-1)-cwt(i))/(w(i-1)-w(i)))*t2
            a1(2:n-1) = ((cwt(2:n-1)-cwt(3:n))/(w(3:n)-w(2:n-1)) + (cwt(1:n-2)-cwt(2:n-1))/(w(1:n-2)-w(2:n-1)))*t2
            !   a2(i)=((swt(i)-swt(i+1))/(w(i+1)-w(i)) + (swt(i-1)-swt(i))/(w(i-1)-w(i)))*t2
            a2(2:n-1) = ((swt(2:n-1)-swt(3:n))/(w(3:n)-w(2:n-1)) + (swt(3:n-2)-swt(2:n-1))/(w(3:n-2)-w(2:n-1)))*t2
            ! end do
            a1(n) = swt(n)/t+(cwt(n-1)-cwt(n))/(w(n-1)-w(n))*t2
            a2(n) = -cwt(n)/t+(swt(n-1)-swt(n))/(w(n-1)-w(n))*t2
        else
            a1(1) = (w(2)-w(1))*0.5
            a2(1) = 0_dp
            !do i=2,n-1
            !   a1(i) = (w(i+1)-w(i-1)) * 0.5
            a1(2:n) = (w(3:n)-w(1:n-1)) * 0.5
            a2 = 0_dp
            ! end do
            a1(n) = (w(n) - w(n-1)) * 0.5
            a2(n) = 0_dp
        end if

        ft1 = sum(a1 * s)  ! real part
        ft2 = sum(a2 * s)  ! imag part
        ft = sqrt(ft1 * ft1 + ft2 * ft2)  ! absolute

        ! error propagation
        dft = sqrt(sum(((a1 * ft1 + a2 * ft2) / ft * ds)**2))

        fft(1) = t
        fft(2) = ft
        fft(3) = dft
        fft(4) = ft1
        fft(5) = ft2

    end function fourier

end module dynamic

!
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2015-2021  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!



module typesandconstants
    ! f2py handles only kind=8  see https://sysbio.ioc.ee/projects/f2py2e/FAQ.html
    ! declaring dp and sp in extra module overcomes that
    implicit none
    integer, parameter :: sp = selected_real_kind(6,37) ! single precision
    integer, parameter :: dp = selected_real_kind(15,307) ! double precision

    real(sp) :: one_sp = 1.0
    real(dp) :: one_dp = 1.0_dp
    real(dp) :: pi_dp =  4.0_dp*ATAN(1.0_dp)
    real(dp) :: pi2_dp =  8.0_dp*ATAN(1.0_dp)
    real(dp) :: golden_dp = 1.618033988749894902525738871191            ! golden ratio
    real(dp) :: ln2 = log(2.0_dp)
    complex(dp) :: j1 = (0,1)                                           ! complex 1j
    complex(dp) :: jzero = (0,0)                                        ! complex zero

contains

subroutine dummy()
    write(*,*) 'This is a dummy'
    end subroutine dummy

end module

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2018  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

! f2py -c fscatter.f95 -m fscatter


module cloud
    use typesandconstants
    use utils


contains

    function ffq(point,r,q,blength,formfactor,rms,ffpolydispersity) result(res)
        use typesandconstants
        use utils
        ! point point on unit sphere 3 x 1
        real(dp), intent(in) :: point(:)
        ! wavevector scalar
        real(8), intent(in) :: q
        ! positions N x 3, scattering length xN
        real(dp), intent(in) :: r(:,:) , blength(:)
        ! formfactor 2xN
        real(dp), intent(in) :: formfactor(:,:)
        ! rms , polydispersity real
        real(dp), intent(in) :: rms, ffpolydispersity
        ! scattering amplitude F and formfactor F*f.conj
        real(dp),dimension(3) :: res

        ! local variables
        real(dp)    :: sizerms(size(r,1)), volrmsfactor(size(r,1)), fa(size(r,1))
        real(dp)    :: qx(3), rg(size(r,1),3), rg1(size(r,1),1) !, rr(size(r,1),3)
        complex(dp) :: iqr(size(r,1))
        complex(dp) :: Fq

        Fq=0*j1
        iqr=0*j1
        rg1=0_dp
        qx=0_dp
        rg=0_dp
        res=0_dp
        sizerms=0_dp
        volrmsfactor=0_dp
        fa=0_dp

        if (ffpolydispersity>0) then
            ! normal distribution of size factor
            rg1=random_gauss(size(r,1),1)
            sizerms = rg1(:,1) * ffpolydispersity + 1_dp
            ! correponding relative volume change
            where( sizerms <= 0._dp )  sizerms=0._dp
            volrmsfactor=sizerms**3
            ! interpolate with rms
            fa = blength *volrmsfactor* interp(sizerms*q, formfactor(1,:), formfactor(2,:))
        else
            !fa=blength
            fa=blength*interp_s(q, formfactor(1,:), formfactor(2,:))
        endif

        qx=q*point
        if (rms>0) then
            rg=random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(r+rg,qx)
        else
            iqr= j1 * matmul(r   ,qx)
        end if

        Fq= sum( fa* exp(iqr) )
        res(1)=q
        res(2)=REALPART(Fq*conjg( Fq ))
        res(3)=REALPART(Fq)

    end function ffq

    function sphereaverage_ffq(q,r,blength,formfactor,rms,ffpolydispersity, relError) result(sphave)
        ! sphere average as average on fibonacci lattice for ffq
        ! returns mean
        ! not used as not faster than actual method
        use typesandconstants
        use utils
        real(dp), intent(in)    :: q, r(:,:), blength(:), formfactor(:,:),rms, ffpolydispersity
        integer, intent(in)     :: relError

        real(dp)                :: qfib(2*relError+1,3),points(2*relError+1,3),results(2*relError+1,3),sphave(3)
        integer                 :: i

        ! create fobonacci lattice
        qfib=fibonacciLatticePointsOnSphere(relError,1.0_dp)
        points=rphitheta2xyz(qfib)    ! to cartesian
        results=0
        do i=1,size(points,1)
            results(i,:)=ffq(points(i,:),r,q,blength,formfactor,rms,ffpolydispersity)
        end do

        sphave(1)=q
        ! calc averages over sphere
        sphave(2)=sum(results(:,2), 1)/size(results,1)
        sphave(3)=sum(results(:,3), 1)/size(results,1)

    end function sphereaverage_ffq

    function ffx(qx,r,fa,rms) result(Sq)
        use typesandconstants
        use utils
        ! point on unit sphere 3 x 1, scattering amplitude, positions , rms
        real(dp), intent(in) :: qx(3), fa, r(:,:), rms
        ! scattering  formfactor Sq
        real(dp)             :: Sq, rr(size(r,1),3)

        ! local variables
        complex(dp) :: iqr(size(r,1)), Fq

        if (rms>0) then
            rr=r+random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(rr,qx)
        else
            iqr= j1 * matmul( r,qx)
        end if

        Fq= sum( fa* exp(iqr) )
        Sq=REALPART(Fq*conjg( Fq ) )

    end function ffx

end module cloud

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2015-2021  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

! f2py -c fscatter.f95 -m fscatter


module cloud
    use typesandconstants
    use utils
    use QSHEP3D_MOD
    !$ use omp_lib
    implicit none

contains

    function ffx(qx,r,fa,rms) result(Sq)
        ! calculates  scattering intensity I=F*conjg(F)
        ! in direction point
        ! adds rms random displacements to positions r

        ! point on unit sphere 3 x 1, scattering amplitude, positions Nx3 , rms
        real(dp), intent(in) :: qx(3), fa(:), r(:,:), rms
        ! scattering  formfactor Sq
        real(dp)             :: Sq, rr(size(r,1),3)

        ! local variables
        complex(dp) :: iqr(size(r,1)), Fq

        rr = 0._dp
        iqr = jzero
        Fq = jzero
        Sq = 0._dp

        if (rms>0) then
            rr=r+random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(rr,qx)
        else
            iqr= j1 * matmul( r,qx)
        end if
        Fq = sum( fa* exp(iqr) )
        Sq = REALPART(Fq*conjg( Fq ) )

    end function ffx

    function ffxa(qx,r,fa,rms) result(Sq)
        ! calculates  scattering intensity I=F*conjg(F) and F
        ! in direction point
        ! adds rms random displacements to positions r

        ! point on unit sphere 3 x 1, scattering amplitude, positions , rms
        real(dp), intent(in) :: qx(3), fa, r(:,:), rms
        ! scattering  formfactor Sq
        real(dp)             :: Sq(2), rr(size(r,1),3)

        ! local variables
        complex(dp) :: iqr(size(r,1)), Fq

        if (rms>0) then
            rr=r+random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(rr,qx)
        else
            iqr= j1 * matmul( r,qx)
        end if

        Fq= sum( fa* exp(iqr) )
        Sq(1)=REALPART(Fq*conjg( Fq ) )
        Sq(2)=REALPART(Fq)

    end function ffxa

    function ffq(point,r,q,blength,iff,formfactor,rms,ffpolydispersity) result(res)
        ! calculates  scattering amplitude F and scattering intensity I=F*conjg(F)
        ! in direction point
        ! scales formfactor for polydispersity and adds rms random displacements to positions r

        ! one point point on unit sphere 3 x 1
        real(dp), intent(in) :: point(:)
        ! wavevector scalar
        real(8), intent(in) :: q
        ! positions N x 3, scattering length xN
        real(dp), intent(in) :: r(:,:) , blength(:)
        ! indices formfactor
        integer, intent(in)     :: iff(:)
        ! formfactor ixN
        real(dp), intent(in) :: formfactor(:,:)
        ! root mean square displacements, polydispersity sigma
        real(dp), intent(in) :: rms, ffpolydispersity
        ! return value with q, formfactor F*f.conjg, scattering amplitude F
        real(dp),dimension(3) :: res

        ! local variables
        real(dp)    :: sizerms(size(r,1)), volrmsfactor(size(r,1)), fa(size(r,1)), fai(size(formfactor,2)-1)
        real(dp)    :: qx(3), rg(size(r,1),3), rg1(size(r,1),1) !, rr(size(r,1),3)
        complex(dp) :: iqr(size(r,1))
        complex(dp) :: Fq
        integer     :: i

        Fq=0*j1
        iqr=0*j1
        rg1=0_dp
        qx=0_dp
        rg=0_dp
        res=0_dp
        sizerms=0_dp
        volrmsfactor=0_dp
        fa=0_dp
        fai=0_dp

        if (ffpolydispersity>0) then
            ! normal distribution of size factor
            rg1=random_gauss(size(r,1),1)
            sizerms = rg1(:,1) * ffpolydispersity + 1_dp
            ! corresponding relative volume change
            where( sizerms <= 0._dp )  sizerms=0._dp
            volrmsfactor=sizerms**3
            ! interpolate with rms
            do i =1,size(r,1)
                fa(i) = blength(i) * volrmsfactor(i) * interp_s(sizerms(i)*q, formfactor(1,:), formfactor(iff(i)+1,:))
            end do
        else
            ! interpolate
            do i =1,size(fai)
                fai(i) = interp_s(q, formfactor(1,:), formfactor(i+1,:))
            end do
            ! distribute according to iff
            do i =1,size(fa,1)
                fa(i)=blength(i)*fai(iff(i))
            end do
        endif

        qx=q*point
        if (rms>0) then
            rg=random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(r+rg,qx)
        else
            iqr= j1 * matmul(r   ,qx)
        end if

        Fq= sum( fa* exp(iqr) )
        res(1)=q
        res(2)=REALPART(Fq*conjg( Fq ))
        res(3)=REALPART(Fq)

    end function ffq

    function sphereaverage_ffq(q,r,blength,iff,formfactor,rms,ffpolydispersity, relError) result(sphave)
        ! sphere average for ffq as orientational average on points distributed on unit sphere
        ! returns mean

        real(dp), intent(in)    :: q, r(:,:), blength(:), formfactor(:,:),rms, ffpolydispersity
        real(dp), intent(in)    :: relError
        integer, intent(in)     :: iff(:)
        real(dp)                :: sphave(3)

        if (relError >1) then
            sphave=sphereaverage_ffqfib(q,r,blength,iff,formfactor,rms,ffpolydispersity, int(relError))
        else
            sphave=sphereaverage_ffq_pseudrand(q,r,blength,iff,formfactor,rms,ffpolydispersity, relError)
        end if
    end function sphereaverage_ffq

    function sphereaverage_ffq_pseudrand(q,r,blength,iff,formfactor,rms,ffpolydispersity, relError) result(sphave)
        ! sphere average  by pseudo random numbers on unit sphere
        ! returns mean

        real(dp), intent(in)    :: q, r(:,:), blength(:), formfactor(:,:),rms, ffpolydispersity
        real(dp), intent(in)    :: relError
        integer, intent(in)     :: iff(:)
        integer                 :: i,npoints
        integer, parameter      :: steps =20
        real(dp)                :: points(steps,3),qsph(steps,3),sphave(3),result(3),mean(3),prevmean(3)

        ! initialisation
        result=0
        npoints=0

        ! first iteration
        qsph=randompointsonsphere(steps, 0, 1.0_dp)
        points=rphitheta2xyz(qsph)
        do i=1,size(points,1)
            result=result+ffq(points(i,:),r,q,blength,iff,formfactor,rms,ffpolydispersity)
            npoints=npoints+1
        end do
        prevmean=result/npoints

        ! increase randompoints until error is small enough
        do
            qsph=randompointsonsphere(steps, npoints, 1.0_dp)
            points=rphitheta2xyz(qsph)
            do i=1,size(points,1)
                result=result+ffq(points(i,:),r,q,blength,iff,formfactor,rms,ffpolydispersity)
                npoints=npoints+1
            end do
            mean=result/npoints
            ! test if error is smaller to break
            if ((abs(mean(2)-prevmean(2))  < relError*abs(mean(2)))  .AND. &
                (abs(mean(3)-prevmean(3))  < relError*abs(mean(3)))) then
                exit
            end if
            prevmean = mean
        end do

        ! return result
        sphave(1)=q
        ! calc averages
        sphave(2)=mean(2)
        sphave(3)=mean(3)

    end function sphereaverage_ffq_pseudrand

    function sphereaverage_ffqfib(q,r,blength,iff,formfactor,rms,ffpolydispersity, relError) result(sphave)
        ! sphere average as average on fibonacci lattice for ffq
        ! returns mean

        real(dp), intent(in)    :: q, r(:,:), blength(:), formfactor(:,:),rms, ffpolydispersity
        integer, intent(in)     :: relError
        integer, intent(in)     :: iff(:)
        real(dp)                :: qfib(2*relError+1,3),points(2*relError+1,3),sphave(3),results(2*relError+1,3)
        integer                 :: i

        ! create Fibonacci lattice on unit sphere
        qfib=fibonacciLatticePointsOnSphere(relError,1.0_dp)
        ! to cartesian coordinates
        points=rphitheta2xyz(qfib)    ! to cartesian
        results=0
        ! for all points
        do i=1,size(points,1)
            results(i,:) = ffq(points(i,:),r,q,blength,iff,formfactor,rms,ffpolydispersity)
        end do
        sphave(1)=q
        ! calc averages
        sphave(2)=sum(results(:,2), 1)/size(results,1)
        sphave(3)=sum(results(:,3), 1)/size(results,1)

    end function sphereaverage_ffqfib

    function average_ffqxyz(q,r,blength,iff,formfactor,rms,ffpolydispersity,points) result(ave)
        ! average ffq on explicit given list of points on unit sphere in cartesian coordinates
        ! returns mean

        ! scattering vector, positions, blength, formfactor, points to average
        real(dp), intent(in)    :: q, r(:,:), blength(:), formfactor(:,:), points(:,:)
        real(dp), intent(in)    :: rms, ffpolydispersity
        integer, intent(in)     :: iff(:)
        real(dp)                :: ave(3),fq(3)
        integer                 :: i

        fq=0
        ave=0
        ! for all points
        do i=1,size(points,1)
            fq=ffq(points(i,:),r,q,blength,iff,formfactor,rms,ffpolydispersity)
            ave(2) = ave(2) + fq(2)
            ave(3) = ave(3) + fq(3)
        end do
        ave(1)=q
        ! calc averages
        ave(2)=ave(2)/size(points,1)
        ave(3)=ave(3)/size(points,1)

    end function average_ffqxyz

    function average_ffqrpt(q,r,blength,iff,formfactor,rms,ffpolydispersity,points) result(ave)
        ! average ffq on explicit given list of points on unit sphere in sperical coordinates for list of q
        ! returns mean

        ! scattering scalar N, positions Nx3, blength N, formfactor Nx?, points to average
        real(dp), intent(in)    :: q(:), r(:,:), blength(:), formfactor(:,:), points(:,:)
        ! rms 1, polydispersity 1
        real(dp), intent(in)    :: rms, ffpolydispersity
        ! index in formfactor N
        integer, intent(in)     :: iff(:)
        real(dp)                :: ave(size(q,1),3), xyz(size(points,1),3)
        integer                 :: i

        ! to cartesian coordinates
        xyz=rphitheta2xyz(points)    ! to cartesian
        do i=1,size(q, 1)
            ave(i,:) = average_ffqxyz(q(i),r,blength,iff,formfactor,rms,ffpolydispersity,xyz)
        end do

    end function average_ffqrpt

    function scattering_Debye(q,r,blength,iff,formfactor,ncpu)  result(qsq)
        ! Debye equation
        ! formfactor need to be normalized
        ! iff defines position in particle formfactor list

        ! scattering vector, particle blength
        real(dp), intent(in)    :: q(:), blength(:)
        ! formfactor ixN, positions
        real(dp), intent(in)    :: formfactor(:,:),r(:,:)
        ! number of cores (negative = not used cores), indices formfactor
        integer, intent(in)     :: ncpu,iff(:)
        integer                 :: k
        ! return value with q, Sq
        real(dp)                :: qsq(2,size(q,1))

        call setncpu(ncpu)

        !$omp parallel do
        do k = 1,size(q,1)
            qsq(:,k) = scattering_Debye_q(q(k), r, blength, iff, formfactor)
        end do
        !$omp end parallel do

    end function scattering_Debye

    function scattering_Debye_q(q,r,blength,iff,formfactor)  result(qsq)
        ! Debye equation  for one q

        ! scattering vector, blength, normalised formfactor ixN, positions
        real(dp), intent(in)    :: q, blength(:),formfactor(:,:),r(:,:)
        ! indices formfactor
        integer, intent(in)     :: iff(:)
        integer                 :: i,j,k
        ! return value with q, Sq
        real(dp)                :: qsq(2),qrij,sq,fa(size(formfactor,2)-1)

        qrij=0
        qsq(1)=q
        qsq(2)=0
        sq=0
        if (q==0) then
            qsq(2)=sum(blength)**2
        else
            do k =1,size(formfactor,2)-1
                fa(k) = interp_s(q, formfactor(1,:), formfactor(k+1,:))
            end do
            do i =1,size(r,1)
                do j=i+1,size(r,1)
                    qrij = q*sqrt(sum((r(i,:)-r(j,:))**2))
                    if (qrij == 0) then
                        ! sin(qrij)/qrij = 1  catch equl r for bad coordinates in some proteins
                        sq = sq + 2*blength(i)*fa(iff(i))*blength(j)*fa(iff(j))
                    else
                        sq = sq + 2*blength(i)*fa(iff(i))*blength(j)*fa(iff(j)) * sin(qrij)/qrij
                    end if
                end do
                sq= sq + blength(i)**2 * fa(iff(i))**2
            end do
            qsq(2)=sq
        end if
    end function scattering_Debye_q

    function mosaicAverage3D_single(qxzw, r, blength, formfactoramp, psi, phi, theta, mosaic, rms, dorient, &
                            &n, x, y, z, f, nr, lcell, lnext, xyzmin, xyzdel, rmax, rsq, a)  result(qsq)
        ! 3D scattering using a 3D formfactoramplitude of particles
        ! uses inverse distance weighting (Shepard's method) as modified from Renka (see toms661.f90)
        ! to interpolate the 3D formfactor

        ! scattering vectors Nx3, blength N , formfactor 4xN
        real(dp), intent(in)     :: qxzw(:,:), blength(:), formfactoramp(:,:)
        ! positions Nx3, orientation angles phi N, theta N, rms, dorient
        real(dp), intent(in)     :: r(:,:), psi(:), phi(:), theta(:), rms, dorient
        ! mosaic orientation x3 to rotate qxzw as rot vector with norm as angle in rad
        real(dp), intent(in)     :: mosaic(3)

        ! interpolation input nodes
        real(dp), intent(in)     :: x(:), y(:), z(:), f(:)
        ! interplation cells and next nodes indices, number of points, number of rows in the cell
        integer(4), intent(in)   :: lcell(:,:,:),lnext(:), n, nr
        ! interpolation output minimum nodal coordinates and cell dimensions, squares of the radii r(k)
        real(dp), intent(in)     :: xyzmin(3), xyzdel(3), rmax, rsq(:)
        ! coefficients for quadratic nodal function Q(K) in column K, interpolated fa
        real(dp) , intent(in)    :: a(:, :)

        ! locals
        integer(4)               :: i, j
        integer(4)               :: xyz(3) = (/1,2,3/)  ! Euler rotation order
        ! rotation vector i in rpt coordinates, rotation matrix, , rotated qxzw
        real(dp)                 :: rot(3,3)
        real(dp)                 :: qrot(3), qxzwf(size(qxzw,1),3), dr(size(r,1),size(r,2)), dor(size(r,1),3)
        ! interpolated fa
        real(dp)                 :: fa(size(r,1))
        ! return value with q, Sq
        real(dp)                 :: qsq(size(qxzw,1))

        ! init
        qsq = 0._dp
        rot = 0._dp
        qrot = 0._dp

        ! rotate all qxzw by single mosaic orientation
        if (sum(abs(mosaic)) > 0.0_dp)  then
            rot = rotationmatrix(mosaic, sqrt(sum(mosaic**2)))
            qxzwf =  transpose(matmul(transpose(rot), transpose(qxzw)))
        else
            ! rotation is diagonal
            qxzwf = qxzw
        end if

        !  add common rms displament to positions and dorient for angles for all qxzwf
        ! this reduces noise for individual qxzwf
        dr = r + random_gauss(size(r,1),size(r,2)) * rms
        dor = random_gauss(size(phi,1),3)*dorient

        ! for all points and calc fa
        do i=1,size(qxzwf,1)
            fa=0._dp
            ! loop over particles to interpolate fa with correct orientation phi,theta
            do j=1,size(r,1)
                ! get rotation matrix to current psi,phi,theta angles
                ! rotation matrix 3x3  but transpose as we rotate q instead of f(xyz)
                rot = transpose(eulerrotationmatrix(xyz, psi(j) + dor(j,1), phi(j)+ dor(j,2), theta(j)+ dor(j,3)))
                ! rotate qxzw(i) and calc fa(j)
                qrot = matmul(rot,qxzwf(i,:))
                fa(j) = QS3VAL( qrot(1), qrot(2), qrot(3), n,x,y,z,f,nr,lcell,lnext,xyzmin,xyzdel,rmax,rsq,a)
            end do
            ! no rms
            qsq(i) = ffx(qxzwf(i,:), dr, blength*fa, 0.0_dp)
        end do

    end function mosaicAverage3D_single

    function mosaicAverage3D(qxzw, mosaic, r, blength, formfactoramp, nr, psi, phi, theta, rms, dorient, ncpu)  result(qsq)
        ! 3D scattering using a 3D formfactoramplitude of particles
        ! uses inverse distance weighting (Shepard's method) as modified from Renka (see toms661.f90)
        ! to interpolate the 3D formfactor
        ! mosaic rotation vectors define define set of orientations to average over (rotate r )

        ! scattering vectors Nx3, mosaic rotation vectors Nx4 to average over, blength N , formfactor 4xN
        real(dp), intent(in)     :: qxzw(:,:),  mosaic(:,:), blength(:), formfactoramp(:,:)
        ! positions Nx3, orientation angles psi N, phi N, theta N, rms, dorient
        real(dp), intent(in)     :: r(:,:), psi(:), phi(:), theta(:), rms, dorient
        ! ncpu, number of rows, columns, and planes in the cell grid =(n/3)**0.333
        integer(4), intent(in)   :: ncpu, nr
        integer(4)               :: n, nq=17, nw=32

        ! locals
        integer(4)               :: i, j, ier

        ! interpolation input nodes
        real(dp)                 :: x(size(formfactoramp,2)),y(size(formfactoramp,2)),z(size(formfactoramp,2))
        real(dp)                 :: f(size(formfactoramp,2)), fa0
        ! interplation cells and next nodes indices
        integer(4)               :: lcell(nr,nr,nr)
        integer(4)               :: lnext(size(formfactoramp,2))
        ! interpolation output minimum nodal coordinates and cell dimensions, squares of the radii r(k)
        real(dp)                 :: xyzmin(3), xyzdel(3), rmax, rsq(size(formfactoramp,2))
        ! coefficients for quadratic nodal function Q(K) in column K, interpolated fa
        real(dp)                 :: a(9,size(formfactoramp,2))

        ! return value with q, Sq
        real(dp)                 :: qsq(size(qxzw,1)), temp(size(qxzw,1))

        call setncpu(ncpu)

        ! init
        n=int(size(formfactoramp,2),4)
        x=formfactoramp(1,:)
        y=formfactoramp(2,:)
        z=formfactoramp(3,:)
        f=formfactoramp(4,:)
        qsq = 0._dp

        ! QSHEP3 precalcs arrays to efficient do 3D lin interpolation
        ! init formfactoramp for interpolation to get coefficients a,lcell, lnext,....
        call QSHEP3 ( n, x, y, z, f, nq, nw, nr, lcell, lnext, xyzmin, xyzdel, rmax, rsq, a, ier )
        if (ier > 0) then
            ! test if QSHEP3 failed
            qsq(:) = -ier
            stop -1
        end if

        ! loop over all points in cone to do orientational average in cone
        !$omp parallel do private(temp)
        do i=1,size(mosaic,1)
            temp = mosaicAverage3D_single(qxzw, r, blength, formfactoramp, psi, phi, theta, mosaic(i,:3),rms, dorient, &
                                        &n, x, y, z, f, nr, lcell, lnext, xyzmin, xyzdel, rmax, rsq, a)
            !$omp critical
            qsq = qsq + temp * mosaic(i,4)
            !$omp end critical
        end do
        !$omp end parallel do

        ! get q=(0,0,0) to normalize
        fa0 = QS3VAL( 0._dp, 0._dp, 0._dp, n,x,y,z,f,nr,lcell,lnext,xyzmin,xyzdel,rmax,rsq,a)

        ! finally normalize
        qsq = qsq / sum(mosaic(:,4))/ fa0**2

    end function mosaicAverage3D

    function mosaicAverage(qxzw, mosaic, r, blength, iff, formfactoramp, rms, ncpu)  result(qsq)
        ! 3D scattering using a 1D formfactoramplitude of particles
        ! linear interpolation of formfactor
        ! mosaic are rotation vectors defining set of orientations to average over (rotate r)
        ! rotation vectors with angle=norm(v(:3)) , rot_vector= v(:3)/norm(v(:3)), probability v(4)

        ! scattering vectors Nx3, mosaic rotation vectors Nx4 to average over, blength N , formfactor 4xN
        real(dp), intent(in)     :: qxzw(:,:),  mosaic(:,:), blength(:), formfactoramp(:,:)
        ! positions Nx3, rms
        real(dp), intent(in)     :: r(:,:), rms
        ! ncpu, index formfactor
        integer(4), intent(in)   :: ncpu, iff(:)

        ! locals
        integer(4)               :: i, j
        ! rotation vector i in rpt coordinates, rotation matrix, rotated qxzw, q scalar
        real(dp)                 :: rot(3,3), qxzwf(size(qxzw,1),3), qnorm(3) ,q, temp(3), dr(size(r,1),size(r,2))
        real(dp)                 :: ffpolydispersity = 0._dp

        ! return value with q, Sq
        real(dp)                 :: qsq(size(qxzw,1),2)

        call setncpu(ncpu)

        ! init
        qsq = 0._dp
        temp = 0._dp

        ! loop over all points in cone to do orientational average in cone
        do i=1,size(mosaic,1)
            ! rotate all qxzw by single mosaic orientation
            ! as we rotate q instead of r we use transposed rot matrix
            if (sum(abs(mosaic(i,:3))) > 0.0_dp)  then
                rot = rotationmatrix(mosaic(i,:3), sqrt(sum(mosaic(i,:3)**2)))
                qxzwf =  transpose(matmul(transpose(rot), transpose(qxzw)))
            else
                ! rotation is diagonal
                qxzwf = qxzw
            end if

            !  add common rms displament to positions for all qxzwf
            ! this reduces noise for individual qxzwf
            dr= r + random_gauss(size(r,1),size(r,2))*rms

            ! for all q points
            !$omp parallel do private(temp, q, qnorm)
            do j=1,size(qxzwf,1)
                ! abs value of q
                q = sqrt(sum(qxzwf(j,:)**2))
                ! we need  normalized qxzwf and ake only the Sq return value in (2)
                if (q>0) then
                    qnorm = qxzwf(j,:) / q
                else
                    qnorm = 1._dp
                end if
                temp = ffq(qnorm, dr, q, blength, iff, formfactoramp, 0._dp, ffpolydispersity)
                !$omp critical
                qsq(j,:) = qsq(j,:) +  temp(2:) * mosaic(i,4)
                !$omp end critical
            end do
            !$omp end parallel do

        end do

        ! finally normalize
        qsq = qsq / sum(mosaic(:,4))

    end function mosaicAverage

    function mda_cohscaint(point,r,fa,q,rms) result(ffq)
        ! coherent scattering in direction point*q

        ! point point on unit sphere 3 x 1
        real(dp), intent(in) :: point(:)
        ! wavevector scalar
        real(8), intent(in) :: q
        ! positions N x 3, position root mean square displacements
        real(dp), intent(in) :: r(:,:), rms
        ! formfactor amplitude xN
        real(dp), intent(in) :: fa(:)
        ! return: q, formfactor F*f.conj, formfactor amplitude
        real(dp),dimension(3) :: ffq

        ! local variables
        real(dp)    :: qx(3), rg(size(r,1),3)
        complex(dp) :: iqr(size(r,1))
        complex(dp) :: Fq

        Fq = 0*j1
        qx = q * point

        if (rms>0) then
            ! rms displacements for each point
            rg=random_gauss(size(r,1),3)*rms
            iqr= j1 * matmul(r+rg,qx)
        else
            iqr= j1 * matmul(r   ,qx)
        end if

        Fq = sum( fa* exp(iqr) )
        ffq(1) = q
        ffq(2) = real(Fq*conjg( Fq ) )
        ffq(3) = real(Fq)

    end function mda_cohscaint

    function mda_sa_cohscaint(q, r, formfactor, qq, nfib, rms) result(sphave)
        ! sphere average as average on fibonacci lattice for coherent scattering
        ! returns mean

        ! N is number of atom positions
        ! single q value, positions Nx3, formfactor amplitude Nxlen(qq), qlist
        real(dp), intent(in)    :: q, r(:,:), formfactor(:,:), qq(:), rms
        integer, intent(in)     :: nfib

        real(dp)                :: qfib(2*nfib+1,3),points(2*nfib+1,3),results(2*nfib+1,3),sphave(3),fa(size(r,1))
        integer                 :: i,iq

        ! create fibonacci lattice
        qfib=fibonacciLatticePointsOnSphere(nfib, 1.0_dp)
        points=rphitheta2xyz(qfib)    ! to cartesian

        ! q values are explicit the same in formfactor list
        do iq=1,size(qq)
            if (qq(iq) >= q ) exit
        end do
        fa = formfactor(:, iq)
        results=0
        do i=1,size(points,1)
            results(i,:) = mda_cohscaint(points(i,:),r,fa,q, rms)
        end do

        sphave(1)=q
        ! calc averages over sphere
        sphave(2)=sum(results(:,2), 1)/size(results,1)
        sphave(3)=sum(results(:,3), 1)/size(results,1)

    end function mda_sa_cohscaint

    function mda_parallel_cohscaint(qlist, r, formfactor, nfib, rms, ncpu) result(result)
        ! sphere average as average on fibonacci lattice for coherent scattering
        ! parallel on ncpu for different scattering vectors

        ! wavevectors, positions Nx3,
        ! formfactors_amplitudes  Nxlen(qq) (not normalized) at same values as qlist for each position, rms
        real(dp), intent(in)    :: qlist(:), r(:,:), formfactor(:,:), rms
        ! points on Fib lattice (nfib*2+1), number of cores (negative = not used cores)
        integer, intent(in)     :: nfib,ncpu
        ! result
        real(dp)                :: result(size(qlist),3)
        ! loop iq
        integer                 :: iq

        call setncpu(ncpu)

        result=0
        !$omp parallel do
        do iq=1,size(qlist)
            result(iq,1:3) = mda_sa_cohscaint(qlist(iq), r, formfactor, qlist, nfib, rms)
        end do
        !$omp end parallel do

    end function mda_parallel_cohscaint

    function mda_scattering_Debye(q,r,formfactor,ncpu)  result(qsq)
        ! Debye equation  definition as in _scattering
        ! This version expects a (not normalized) formfactor for each position r and correct q values as in q

        ! scattering vector, particle blength
        real(dp), intent(in)    :: q(:)
        ! formfactor amplitude Nxlen(q), positions Nx3
        real(dp), intent(in)    :: formfactor(:,:), r(:,:)
        ! number of cores (negative = not used cores), indices formfactor
        integer, intent(in)     :: ncpu
        integer                 :: k
        ! return value with q, Sq
        real(dp)                :: qsq(2,size(q,1))

        call setncpu(ncpu)

        !$omp parallel do
        do k = 1,size(q,1)
            qsq(:,k) = mda_scattering_Debye_q(q(k), r, formfactor(:,k))
        end do
        !$omp end parallel do

    end function mda_scattering_Debye

    function mda_scattering_Debye_q(q, r, fa)  result(qsq)
        ! Debye equation  for one q
        ! This version expects a (not normalized) formfactor for each position r and correct q values as in q
        ! to avoid interpolation

        ! scattering vector, blength, positions Nx3, formfactor ampl N
        real(dp), intent(in)    :: q, r(:,:), fa(:)
        integer                 :: i,j
        ! return value with q, Sq
        real(dp)                :: qsq(2)
        real(dp)                :: qrij,sq

        qrij=0
        qsq(1)=q
        qsq(2)=0
        sq=0
        if (q==0) then
            qsq(2)=sum(fa)**2
        else
            do i =1,size(r,1)
                ! upper diagonal *2
                do j=i+1,size(r,1)
                    qrij = q*sqrt(sum((r(i,:)-r(j,:))**2))
                    sq= sq + 2*fa(i)*fa(j)*sin(qrij)/qrij
                end do
                ! diagonal once
                sq= sq + fa(i)**2
            end do
            qsq(2)=sq
        end if

    end function mda_scattering_Debye_q

    function mda_cohinterscat_ou(point,q,r,bdisplace,vdisplace,fa,b2inc,tlist,irt) result(ou)
        ! coherent intermediate scattering in direction point*q
        ! bdisplace are real displacements in bronwian modes
        ! vdisplace are real displacements in vibrational modes,

        ! point point on unit sphere 3 x 1, wavevectors, positions, formfactors(q)
        real(dp), intent(in)    :: point(:), q, r(:,:), fa(:)
        !brownian displacement for all modes, same vibrational modes, b2incoherent for all atoms
        real(dp), intent(in)    :: bdisplace(:,:,:),vdisplace(:,:,:),b2inc(:)
        ! timelist , mode relaxation time
        real(dp), intent(in)    :: tlist(:),irt(:)

        ! local variables
        real(dp)    :: qx(3)
        complex(dp) :: iqr(size(r,1)),sqt(size(tlist,1)+3)
        complex(dp) :: beiqr(size(r,1)),beiqrc(size(r,1)),beiqr_ij
        real(dp)    :: qbmodes(size(bdisplace,1),size(bdisplace,2))
        real(dp)    :: qvmodes(size(vdisplace,1),size(vdisplace,2))
        real(dp)    :: qvmodes2(size(vdisplace,1),size(vdisplace,2))
        real(dp)    :: elambdat(size(irt,1),size(tlist,1))
        real(dp)    :: fab_q_t(size(r,1),size(r,1),size(tlist,1))
        real(dp)    :: fab_q_0(size(r,1),size(r,1))
        real(dp)    :: fab_q_inf(size(r,1),size(r,1))
        real(dp)    :: fab_q_00( size(r,1),size(r,1))
        integer(dp) :: i,j,k,tl
        real(dp)    :: ou(size(tlist,1)+3)

        sqt = j1*0 ! complex zero
        fab_q_inf = 0
        fab_q_00  = 0
        fab_q_t   = 0
        fab_q_0   = 0
        qvmodes = 0
        qbmodes = 0
        qvmodes2 = 0

        qx = q*point
        iqr = j1 * matmul( r,qx)
        beiqr =  fa * exp(iqr)                              ! reciprocal density
        beiqrc = conjg( beiqr )

        do i = 1,size(bdisplace,1)
            qbmodes(i,:)=matmul(bdisplace(i,:,:),qx)       ! displacement projection for brownian modes
        end do
        do i = 1,size(vdisplace,1)
            qvmodes(i,:)=matmul(vdisplace(i,:,:),qx)       ! same for vibrational modes
        end do
        qvmodes2 = qvmodes**2                                ! square of above
        forall(i=1:size(irt,1))
            elambdat(i,:) = exp(-1.*irt(i)*tlist)          ! relaxation of mode i ; tlist is ft[i,:]
        end forall

        ! for all atoms i,j and times k  sum over modes :   here bmodes with time dependence
        do i=1,size(r,1)
            do j=1,size(r,1)
                do k=1,size(tlist,1)
                    ! brownian amplitude relaxation
                    fab_q_t(i,j,k) = exp(sum(qbmodes(:,i)*qbmodes(:,j)*elambdat(:,k) ))
                end do
                ! amplitude t=0
                fab_q_0(i,j)      = exp(sum(qbmodes(:,i)*qbmodes(:,j)))
            end do
        end do
        ! for all atoms i,j and times k  sum over modes : , here vmodes
        do i=1,size(r,1)
            do j=1,size(r,1)
                fab_q_inf(i,j) = exp(-0.5*sum(  qvmodes2(:,i)+ qvmodes2(:,j))      )  ! t=inf
                fab_q_00(i,j)  = exp(-0.5*sum(( qvmodes(:,i) - qvmodes(:,j ))**2 ) )  ! t=0
            end do
        end do

        !sum over particles i+j
        tl=size(tlist)
        do i=1,size(beiqr,1)
            do j=1,size(beiqrc,1)
                beiqr_ij = beiqr(i)*beiqrc(j)
                ! amplitude at t=0, equ 79 with 81 in [1]_
                sqt(1) = sqt(1)          + beiqr_ij*fab_q_inf(i,j)*fab_q_0(i,j)
                ! amplitude at t=0 , equ 50 in [1]_
                sqt(2) = sqt(2)          + beiqr_ij*fab_q_00(i,j)
                ! full relaxation for all t, equ 79 with 81 in [1]_
                sqt(3:2+tl) = sqt(3:2+tl)+ beiqr_ij*fab_q_inf(i,j)*fab_q_t(i,j,:)
                ! amplitude at t=infinity , equ 49 in [1]_
                sqt(tl+3) = sqt(tl+3)    + beiqr_ij*fab_q_inf(i,j)
            end do

        end do

        ou = REALPART(sqt)                ! returns [Sqt0,Sqt00,Sqt(:),Sqtinf]

    end function mda_cohinterscat_ou

    function mda_sa_cohinterscat_ou(iq,qlist,r,bdisplace,vdisplace,formfactors,b2inc,tlist,irt,nfib) result(sphave)
        ! sphere average as average on fibonacci lattice for coherent scattering
        ! returns mean

        ! wavevectors, positions, formfactors (not normalized) at same values as qlist for each position
        real(dp), intent(in)    :: r(:,:), formfactors(:,:)
        !brownian displacement for all modes, same vibrational modes, b2incoherent for all atoms
        real(dp), intent(in)    :: bdisplace(:,:,:),vdisplace(:,:,:)
        ! timelist , mode relaxation time
        real(dp), intent(in)    :: qlist(:),tlist(:),irt(:),b2inc(:)
        ! points on Fib lattice (nfib*2+1), number of cores (negative = not used cores)
        integer, intent(in)     :: nfib,iq

        real(dp)                :: qfib(2*nfib+1,3),points(2*nfib+1,3)
        real(dp)                :: results(2*nfib+1,size(tlist)+3),sphave(size(tlist)+3),fa(size(r,1))
        integer                 :: i

        ! create fibonacci lattice
        qfib=fibonacciLatticePointsOnSphere(nfib,1.0_dp)
        points=rphitheta2xyz(qfib)    ! to cartesian

        ! q values are explicit the same in formfactor list
        fa=formfactors(:, iq)
        results=0
        ! doit for all points on sphere
        !$omp parallel do if(size(qlist)<=2)
        do i=1,size(points,1)
            results(i,:) = mda_cohinterscat_ou(points(i,:),qlist(iq),r,bdisplace,vdisplace,fa,b2inc,tlist,irt)
        end do
        !$omp end parallel do
        ! calc averages over sphere
        sphave(:)=sum(results, 1)/size(results,1)

    end function mda_sa_cohinterscat_ou

    function mda_parallel_cohinterscat_ou(qlist,r,bdisplace,vdisplace,formfactors,b2inc,tlist,irt,nfib,ncpu) result(psou)
        ! calculates the coherent intermediate scattering function I(q,t) for Ornstein-Uhlenbeck process
        ! based on displacements along normal modes in harmonic potential
        ! as eigenvectors of friction-weighted force constant matrix
        ! relaxation by Brownian normal modes as overdamped relaxation
        ! Inelastic neutron scattering from damped collective vibrations of macromolecules
        ! Gerald R. Kneller, Chemical Physics 261, 1-24, (2000)

        ! qlist and formfactors need to be in sync

        ! wavevectors, positions, formfactors (not normalized) at same values as qlist for each position
        real(dp), intent(in)    :: qlist(:), r(:,:), formfactors(:,:)
        !brownian displacement for all modes, same vibrational modes, b2incoherent for all atoms
        real(dp), intent(in)    :: bdisplace(:,:,:),vdisplace(:,:,:),b2inc(:)
        ! timelist , mode relaxation time
        real(dp), intent(in)    :: tlist(:),irt(:)
        ! points on Fib lattice (nfib*2+1), number of cores (negative = not used cores)
        integer, intent(in)     :: nfib,ncpu
        ! result
        real(dp)                :: psou(size(qlist),size(tlist)+3)
        ! loop iq, num of threads
        integer                 :: iq

        call setncpu(ncpu)

        psou=0
        !$omp parallel do if(size(qlist)>2)
        do iq=1,size(qlist)
            psou(iq,:) = mda_sa_cohinterscat_ou(iq,qlist,r,bdisplace,vdisplace,formfactors,b2inc,tlist,irt,nfib)
        end do
        !$omp end parallel do

    end function mda_parallel_cohinterscat_ou

end module cloud

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2018  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

! f2py -c fscatter.f95 -m fscatter


module utils

    use typesandconstants

contains

function random_gauss(dim1,dim2) result(rg)
    ! Gaussian random number with center 0 and 1-sigma =1 with shape of (dim1,dim2)
    ! uses Box-Muller transform
    use typesandconstants
    integer, intent(in) :: dim1,dim2
    real(dp), dimension(dim1,dim2) :: r, rg
    integer(dp) :: i
    r=0
    rg=0
    CALL RANDOM_NUMBER(r)
    do i=1,dim1-1,2
        rg(i,:)   = SQRT(-2_dp*LOG(r(i,:))) * COS(2_dp*pi_dp*r(i+1,:))
        rg(i+1,:) = SQRT(-2_dp*LOG(r(i,:))) * SIN(2_dp*pi_dp*r(i+1,:))
    end do
end function random_gauss

function interp(x,y,fy)
    ! linear interpolation of sorted array
    ! if x is out of range the upper or lower boundary value is returned
    use typesandconstants
    real(dp),           intent(in)   :: x(:),y(:),fy(:)
    real(dp), dimension(size(x))    :: interp
    integer                          :: i,j,imax ,jmax

    imax=size(x)
    jmax=size(y)
    do i =1,imax
        if  (x(i)<= y(1)) then
            interp(i)=fy(1)
        else if  (x(i)>=y(jmax)) then
            interp(i)=fy(jmax)
        else
            do j=1, jmax
                if  ( y(j)<=x(i) .and. x(i)<y(j+1) )    exit
            end do
            interp(i)=interp1d_single(y(j),fy(j),y(j+1),fy(j+1),x(i))
        end if
    end do
end function interp

function interp_s(x,y,fy) result(ip2)
    ! single value linear interpolation of sorted array
    ! if x is out of range the upper or lower boundary value is returned
    use typesandconstants
    real(dp),           intent(in)   :: x,y(:),fy(:)
    real(dp)                         :: res(1),ip2

    res=interp([x],y,fy)
    ip2=res(1)

end function interp_s


function interp1d_single(x1,y1,x2,y2,xval)
    ! linear interpolation
    ! xval outside interval are linear extrapolated
    use typesandconstants
    real(dp),intent(in) :: x1,y1,x2,y2,xval
    real(dp) :: frac, interp1d_single
    frac = ( xval - x1 ) / ( x2 - x1 )
    interp1d_single = y1 + frac * ( y2 - y1 )
end function interp1d_single

function fibonaccilatticepointsonsphere(NN, r) result(lattice)
    ! create a Finonacci lattice with NN*2+1 points on sphere with radius r
    ! returns spherical coordinates r,theta, phi
    use typesandconstants
    integer,  intent(in)                :: NN
    real(dp), intent(in)                :: r

    real(dp), dimension(2*NN+1)         :: n
    integer                             :: i
    real(dp),dimension(2*NN+1,3)        :: lattice

    do i = 1,2*NN+1
        n(i)=(i-NN-1_dp)
    end do

    lattice(:,1)= r
    lattice(:,2)=  modulo((2*pi_dp * n / golden_dp) + pi_dp,  2*pi_dp) - pi_dp
    lattice(:,3)= asin(2_dp*n / (2 * NN + 1.)) + pi_dp / 2_dp

end function fibonaccilatticepointsonsphere

function randompointsonsphere(NN, r) result(lattice)
    ! create a random points on sphere with radius r
    ! returns spherical coordinates r,theta, phi
    use typesandconstants
    integer,  intent(in)                :: NN
    real(dp), intent(in)                :: r

    real(dp), dimension(2*NN+1)         :: n
    real(dp),dimension(2*NN+1,3)        :: lattice

    lattice(:,1)= r
    CALL RANDOM_NUMBER(n)
    lattice(:,2)= 2*pi_dp*n- pi_dp
    CALL RANDOM_NUMBER(n)
    lattice(:,3)=ACOS(2*n - 1)

end function randompointsonsphere

function rphitheta2xyz(rpt) result(xyz)
    ! transform rpt coordinates to cartesian
    use typesandconstants
    real(dp), intent(in)    :: rpt(:,:)
    real(dp),dimension(size(rpt,1),3) :: xyz

    xyz(:,1)=rpt(:,1)*cos(rpt(:,2))*sin(rpt(:,3))
    xyz(:,2)=rpt(:,1)*sin(rpt(:,2))*sin(rpt(:,3))
    xyz(:,3)=rpt(:,1)*cos(rpt(:,3))

end function rphitheta2xyz


end module utils

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2020  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

module dynamic
    use typesandconstants
    use utils
    !$ use omp_lib
    implicit none

contains

    function bnmt(t, NN, l, mu, modeamplist, tp)
        ! Rouse/Zimm mode summation coherent +incoherent +modeamplitudes

        ! times, mu, modeamplitudes, relaxation times, bond length
        real(dp), intent(in) :: t(:), mu, modeamplist(:), tp(:), l
        ! number beads, mode numbers n,m
        integer, intent(in)  :: NN
        ! result (n*m,tcoh + tinc + mode amplitudes (as t_inf))
        real(dp)             :: bnmt(NN*NN, 2*size(t) + size(modeamplist))
        ! internal stuff
        integer              :: p, n, m

        ! init
        bnmt = 0_dp
        !$omp parallel do
        do m = 1, NN
            do n = 1, NN
                do p = 1, size(modeamplist)
                    bnmt((n-1)*NN+m,:size(t)) = bnmt((n-1)*NN+m,:size(t)) + &
                            modeamplist(p) * cos(pi_dp * p * n / NN) * cos(pi_dp * p * m / NN) * (1 - exp(-t/tp(p)))
                    ! each p for mode amplitudes and later infinite time is sum_p( mode amplitudes)
                    bnmt((n-1)*NN+m,2*size(t)+p) = bnmt((n-1)*NN+m,2*size(t)+p) + &
                            modeamplist(p) * cos(pi_dp * p * n / NN) * cos(pi_dp * p * m / NN)
                    if (n == m) then
                        bnmt((n-1)*NN+m,size(t):2*size(t)) = bnmt((n-1)*NN+m,size(t):2*size(t)) + &
                                modeamplist(p) * cos(pi_dp * p * n / NN) **2  * (1 - exp(-t/tp(p)))
                    end if
                end do
                bnmt((n-1)*NN+m,:) = bnmt((n-1)*NN+m,:) + (abs(n - m) ** (2 * mu) * l ** 2)
            end do
        end do
        !$omp end parallel do

    end function bnmt




end module dynamic

! William I. Thacker, Jingwei Zhang, Layne T. Watson, Jeffrey B. Birch, Manjula A. Iyer, and Michael W. Berry. 2010.
! Algorithm 905: SHEPPACK: Modified Shepard Algorithm for Interpolation of Scattered Multivariate Data.
! ACM Trans. Math. Softw. 37, 3, Article 34 (September 2010), 20 pages.
! DOI:https://doi.org/10.1145/1824801.1824812
!
! This file is uses only QSHEP3D, QS3VAL and related from above to work as a single file.
! Precision is increased from SELECTED_REAL_KIND(13) to SELECTED_REAL_KIND(15,307) correponding to 64bit.
! Original package is contained as attachement to above article or http://netlib.org/toms/905.zip
! License is according to https://www.acm.org/publications/policies/software-copyright-notice

  MODULE REAL_PRECISION  ! module for 64-bit arithmetic
    INTEGER, PARAMETER:: R8=SELECTED_REAL_KIND(15,307)
  END MODULE REAL_PRECISION

  MODULE QSHEP3D_MOD
    use REAL_PRECISION
    IMPLICIT NONE

! removed to allow easy compilation with f2py
!  PRIVATE
!  PUBLIC QSHEP3, QS3VAL, QS3GRD
  CONTAINS

  SUBROUTINE QSHEP3 (N, X, Y, Z, F, NQ, NW, NR, LCELL, LNEXT, &
    XYZMIN, XYZDEL, RMAX, RSQ, A, IER)
!
! QSHEP3 defines a smooth trivariate interpolant of scattered 3D data.
!
! Discussion:
!
!   This subroutine computes a set of parameters, A and RSQ,
!   defining a smooth (once continuously differentiable) trivariate 
!   function Q(X,Y,Z) which interpolates data values
!   F at scattered nodes (X,Y,Z). The interpolant Q may be
!   evaluated at an arbitrary point by the function QS3VAL, and
!   its first derivatives are computed by the subroutine QS3GRD.
!
!   The interpolation scheme is a modified quadratic Shepard
!   method. 
!
!   Q = (W(1)*Q(1)+W(2)*Q(2)+...+W(N)*Q(N)) / (W(1)+W(2)+...+W(N))
!   for trivariate functions W(K) and Q(K).  
!
!   The nodal functions are given by
!     Q(K)(X,Y,Z) =  A(1,K) * DX**2 
!                  + A(2,K) * DX * DY 
!                  + A(3,K) * DY**2
!                  + A(4,K) * DX * DZ
!                  + A(5,K) * DY * DZ 
!                  + A(6,K) * DZ**2
!                  + A(7,K) * DX 
!                  + A(8,K) * DY 
!                  + A(9,K) * DZ 
!                  + F(K), 
!
!   where DX = (X-X(K)), DY = (Y-Y(K)), and DZ = (Z-Z(K)).
!
!   Thus, Q(K) is a quadratic function which interpolates the
!   data value at node K. Its coefficients A(*,K) are obtained
!   by a weighted least squares fit to the closest NQ data
!   points with weights similar to W(K). Note that the radius
!   of influence for the least squares fit is fixed for each
!   K, but varies with K.
!
!   The weights are taken to be
!     W(K)(X,Y,Z) = ( (R(K)-D(K))+ / R(K)*D(K) )**2, 
!
!   where (R(K)-D(K))+ = 0 if R(K) <= D(K), and D(K)(X,Y,Z)
!   is the Euclidean distance between (X,Y,Z) and node K. The
!   radius of influence R(K) varies with K and is chosen so
!   that NW nodes are within the radius. Note that W(K) is
!   not defined at node (X(K),Y(K),Z(K)), but Q(X,Y,Z) has
!   limit F(K) as (X,Y,Z) approaches (X(K),Y(K),Z(K)).
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT 
!   N, integer, the number of nodes and associated data 
!   values. N >= 10.
!
!   X(N), Y(N), Z(N), real, the coordinates of the nodes.
!
!   F(N), real, the data values at the nodes.
!
!   NQ, integer, the number of data points to be used in the least
!   squares fit for coefficients defining the nodal functions Q(K).  
!   A recommended value is NQ = 17. 9 <= NQ <= MIN (40, N-1).
!
!   NW, integer, the number of nodes within (and defining) the radii
!   of influence R(K), which enter into the weights W(K). For N sufficiently
!   large, a recommended value is NW = 32. 1 <= NW <= MIN(40,N-1).
!
!   NR, integer, the number of rows, columns, and planes in the cell
!   grid defined in the subroutine STORE3. A box containing the nodes is
!   partitioned into cells in order to increase search efficiency.  
!   NR = (N/3)**(1/3) is recommended. NR >= 1.
!
!  OUTPUT
!   LCELL(NR,NR,NR), integer, nodal indices associated with cells.  
!   Refer to STORE3.
!
!   LNEXT(N), integer, next-node indices. Refer to STORE3.
!
!   XYZMIN(3), XYZDEL(3) real,  arrays of length 3 containing 
!   minimum nodal coordinates and cell dimensions, respectively.  
!   Refer to STORE3.
!
!   RMAX real,  square root of the largest element in RSQ,
!   the maximum radius of influence.
!
!   RSQ(N) real,  array containing the squares of the radii R(K),
!   which enter into the weights W(K).
!
!   A(9,N), real, the coefficients for the quadratic nodal 
!   function Q(K) in column K.
!
!   integer IER, error indicator.
!     0, if no errors were encountered.
!     1, if N, NQ, NW, or NR is out of range.
!     2, if duplicate nodes were encountered.
!     3, if all nodes are coplanar.
!
! Local variables:
!
!   AV =        Root-mean-square distance between node K and the nodes in the 
!               least squares system (unless additional nodes are introduced
!               for stability). The first 6 columns of the matrix are 
!               scaled by 1/AVSQ, the last 3 by 1/AV.
!
!   AVSQ =      AV*AV.
!
!   B =         Transpose of the augmented regression matrix.
!
!   C =         First component of the plane rotation used to zero 
!               the lower triangle of B**T, computed by the subroutine GIVENS.
!
!   DMIN =      Minimum of the magnitudes of the diagonal elements of 
!               the regression matrix after zeros are introduced below 
!               the diagonal.
!
!   DTOL =      Tolerance for detecting an ill-conditioned system. 
!               The system is accepted when DMIN >= DTOL.
!
!   FK =        Data value F(K) at node K. 
!
!   I =         Index for A, B, NPTS, XYZMIN, XYZMN, XYZDEL, and XYZDL.
!
!   IB =        Do-loop index for back solve.
!
!   IERR =      Error flag for the call to STORE3.
!
!   IP1 =       I+1.
!
!   IRM1 =      IROW-1.
!
!   IROW =      Row index for B.
!
!   J =         Index for A and B.
!
!   JP1 =       J+1.
!
!   K =         Nodal function index and column index for A.
!
!   LMAX =      Maximum number of NPTS elements (must be consistent 
!               with the dimension of NPTS in the variable declaration section).
!
!   LNP =       Current length of NPTS.
!
!   NEQ =       Number of equations in the least squares fit.
!
!   NN =        Local copy of N.
!
!   NNQ =       Local copy of NQ.
!
!   NNR =       Local copy of NR.
!
!   NNW =       Local copy of NW.
!
!   NP =        NPTS element.
!
!   NPTS =      Array containing the indices of a sequence of nodes to be
!               used in the least squares fit or to compute RSQ. The nodes 
!               are ordered by distance from K and the last element
!               (usually indexed by LNP) is used only to determine RQ, 
!               or RSQ(K) if NW > NQ.
!
!   NQWMAX =    MAX(NQ,NW).
!
!   RQ =        Radius of influence, which enters into the weights for Q(K).
!               (See subroutine SETUP3).
!
!   RS =        Squared distance between node K and NPTS(LNP). 
!               Used to compute RQ and RSQ(K).
!
!   RSMX =      Maximum RSQ element encountered.
!
!   RSOLD =     Squared distance between node K and NPTS(LNP-1). Used to 
!               compute a relative change in RS between succeeding 
!               NPTS elements.
!
!   RTOL =      Tolerance for detecting a sufficiently large relative 
!               change in RS. If the change is not greater than RTOL,
!               the nodes are treated as being the same distance from K.
!
!   RWS =       Current value of RSQ(K).
!
!   S =         Second component of the plane Givens rotation.
!
!   SF =        Marquardt stabilization factor used to damp out the 
!               first 6 solution components (second partials of the 
!               quadratic) when the system is ill-conditioned. As 
!               SF increases, the fitting function becomes more linear.
!
!   SUM2 =      Sum of squared Euclidean distances between node K and 
!               the nodes used in the least squares fit 
!               (unless additional nodes are added for stability).
!
!   T =         Temporary variable for accumulating a scalar product 
!               in the back solve.
!
!   XK,YK,ZK =  Coordinates X(K), Y(K), Z(K) of node K.
!
!   XYZDL =     Local variables for XYZDEL.
!
!   XYZMN =     Local variables for XYZMIN.
!

    INTEGER :: I, IB, IER, IERR, IP1, IRM1, IROW, J, JP1, K, LMAX, LNP, &
        N, NEQ, NN, NNQ, NNR, NNW, NP, NQ, NQWMAX, NR, NW
    INTEGER, DIMENSION (N) :: LNEXT
    INTEGER, DIMENSION (40) :: NPTS
    INTEGER, DIMENSION (NR,NR,NR) :: LCELL

    REAL(KIND=R8):: AV, AVSQ, C, DMIN
    REAL(KIND=R8):: DTOL
    REAL(KIND=R8):: FK, RMAX, RQ, RS, RSMX, RSOLD
    REAL(KIND=R8), PARAMETER :: RTOL = 1.0E-05
    REAL(KIND=R8):: RWS, S
    REAL(KIND=R8), PARAMETER :: SF = 1.0E+00
    REAL(KIND=R8):: SUM2, T, XK, YK, ZK
    REAL(KIND=R8), DIMENSION (N) :: F, RSQ, X
    REAL(KIND=R8), DIMENSION (3) :: XYZDEL, XYZDL, XYZMIN, XYZMN
    REAL(KIND=R8), DIMENSION (N) :: Y, Z
    REAL(KIND=R8), DIMENSION (9,N) :: A
    REAL(KIND=R8), DIMENSION (10,10) :: B

    DTOL = SQRT(EPSILON(1.0_R8))
    NN = N
    NNQ = NQ
    NNW = NW
    NNR = NR
    NQWMAX = MAX(NNQ,NNW)
    LMAX = MIN(40,NN-1)

    IF (9 > NNQ .OR.  1 > NNW  .OR.  NQWMAX > &
          LMAX  .OR.  NNR < 1) THEN
!
! N, NQ, NW, or NR is out of range.
!
        IER = 1
        RETURN
    END IF
!
! Create the cell data structure, and initialize RSMX.
!
    CALL STORE3 (NN, X, Y, Z, NNR, LCELL, LNEXT, XYZMN, XYZDL, IERR)

    IF (IERR /= 0) THEN
        XYZMIN(1:3) = XYZMN(1:3)
        XYZDEL(1:3) = XYZDL(1:3)
        IER = 3
        RETURN
    END IF
    RSMX = 0.0E+00_R8
!
! Outer loop on node K.
!
    DO K = 1, NN
        XK = X(K)
        YK = Y(K)
        ZK = Z(K)
        FK = F(K)
!
!  Mark node K to exclude it from the search for nearest neighbors.
!
        LNEXT(K) = -LNEXT(K)
!
!  Initialize for loop on NPTS.
!
        RS = 0.0E+00_R8
        SUM2 = 0.0E+00_R8
        RWS = 0.0E+00_R8
        RQ = 0.0E+00_R8
        LNP = 0
!
! Compute NPTS, LNP, RWS, NEQ, RQ, and AVSQ.
!
        MAIN: DO
            SUM2 = SUM2 + RS
            IF (LNP == LMAX) THEN
!       
! All LMAX nodes are included in NPTS. RWS and/or RQ**2 are
! (arbitrarily) taken to be 10 percent larger than the
! distance RS to the last node included.
!
                IF (RWS == 0.0E+00_R8) RWS = 1.1E+00_R8 * RS
                IF (RQ == 0.0E+00_R8) THEN
                    NEQ = LMAX
                    RQ = SQRT (1.1_R8 * RS)
                    AVSQ = SUM2 / REAL (NEQ, KIND=R8)
                END IF
!
! Store RSQ(K), update RSMX if necessary, and compute AV.
!
                RSQ(K) = RWS
                IF (RWS > RSMX) RSMX = RWS
                AV = SQRT(AVSQ)
                EXIT
            END IF    
            LNP = LNP + 1
            RSOLD = RS
            CALL GETNP3 (N, XK, YK, ZK, X, Y, Z, NNR, LCELL, LNEXT, XYZMN, &
                  XYZDL, NP, RS)
            IF (RS == 0.0E+00_R8) THEN
!
! Duplicate nodes were encountered by GETNP3.
!
                IER = 2
                RETURN
            END IF
            NPTS(LNP) = NP
            IF ((RS-RSOLD)/RS <  RTOL) CYCLE MAIN
            IF (RWS == 0.0E+00_R8 .AND.  LNP > NNW) RWS = RS
            IF (.NOT.( RQ /= 0.0E+00_R8  .OR.  LNP <= NNQ )) THEN
!
! RQ = 0 (not yet computed) and LNP > NQ.  
! RQ = SQRT(RS) is sufficiently large to (strictly) include
! NQ nodes. The least squares fit will include 
! NEQ = LNP-1 equations for 9 <= NQ <= NEQ < LMAX <= N-1.
!
                NEQ = LNP - 1
                RQ = SQRT(RS)
                AVSQ = SUM2 / REAL (NEQ, KIND=R8)
!
! Bottom of loop, test for termination.
!
            ELSE
                IF (LNP > NQWMAX) THEN
!
! Store RSQ(K), update RSMX if necessary, and compute AV.
!
                    RSQ(K) = RWS
                    IF (RWS > RSMX) RSMX = RWS
                    AV = SQRT(AVSQ)
                    EXIT
                END IF
            END IF
        END DO MAIN
!
! Set up the augmented regression matrix (transposed) as the
! columns of B, and zero out the lower triangle (upper
! triangle of B) with Givens rotations. QR decomposition
! with orthogonal matrix Q is not stored.
!
        I = 0
        PTS: DO
            I = I + 1
            NP = NPTS(I)
            IROW = MIN0(I,10)
            CALL  SETUP3 (XK, YK, ZK, FK, X(NP), Y(NP), Z(NP), F(NP),&
                    AV, AVSQ, RQ, B(1,IROW))
            IF (I == 1) CYCLE PTS
            IRM1 = IROW-1
            DO J = 1, IROW-1
                JP1 = J + 1
                CALL GIVENS (B(J,J),B(J,IROW),C,S)
                CALL ROTATE (10-J,C,S,B(JP1,J),B(JP1,IROW))
            END DO
            IF (I < NEQ) CYCLE PTS
!
! Test the system for ill-conditioning.
!
            DMIN = MIN (ABS(B(1,1)),ABS(B(2,2)),ABS(B(3,3)), &
                    ABS(B(4,4)),ABS(B(5,5)),ABS(B(6,6)), &
                    ABS(B(7,7)),ABS(B(8,8)),ABS(B(9,9)))

            IF (DMIN * RQ >= DTOL) EXIT
            IF (NEQ == LMAX) EXIT
!
! Increase RQ and add another equation to the system to
! improve the conditioning. The number of NPTS elements
! is also increased if necessary.
!
            TOL: DO
                RSOLD = RS
                NEQ = NEQ + 1
                IF (NEQ == LMAX) THEN
                    RQ = SQRT (1.1E+00_R8 * RS)
                    CYCLE PTS
                END IF
                IF (NEQ == LNP) THEN
!
! Add an element to NPTS.
!
                    LNP = LNP + 1
                    CALL GETNP3 (N, XK, YK, ZK, X, Y, Z, NNR, LCELL, LNEXT, &
                          XYZMN, XYZDL, NP, RS)
                    IF (NP == 0) THEN
!
! Duplicate nodes were encountered by GETNP3.
!
                        IER = 2
                        RETURN
                    END IF
                    NPTS(LNP) = NP
                    IF ((RS-RSOLD)/RS < RTOL) CYCLE TOL
                    RQ = SQRT (RS)
                    CYCLE PTS
                END IF
!
! NEQ < LNP.
!
                NP = NPTS(NEQ+1)
                RS = (X(NP)-XK)**2 + (Y(NP)-YK)**2 + (Z(NP)-ZK)**2
                IF ((RS-RSOLD)/RS < RTOL) CYCLE TOL
                RQ = SQRT(RS)
                CYCLE PTS
            END DO TOL
        END DO PTS
!
! Stabilize the system by damping second partials. Add
! multiples of the first six unit vectors to the first
! six equations.
!
        IF (NEQ == LMAX) THEN
            DO I = 1, 6
                B(I,10) = SF
                IP1 = I + 1
                DO J = IP1, 10
                    B(J,10) = 0.0E+00_R8
                END DO
                DO J = I, 9
                    JP1 = J + 1
                    CALL GIVENS (B(J,J),B(J,10),C,S)
                    CALL ROTATE (10-J,C,S,B(JP1,J),B(JP1,10))
                END DO
            END DO
!
! Test the stabilized system for ill-conditioning.
!
            DMIN = MIN ( ABS(B(1,1)),ABS(B(2,2)),ABS(B(3,3)), &
                  ABS(B(4,4)),ABS(B(5,5)),ABS(B(6,6)), &
                  ABS(B(7,7)),ABS(B(8,8)),ABS(B(9,9)) )
            IF (DMIN * RQ < DTOL) THEN
!
! No unique solution due to collinear nodes.
!
                XYZMIN(1:3) = XYZMN(1:3)
                XYZDEL(1:3) = XYZDL(1:3)
                IER = 3
                RETURN
            END IF
        END IF
!
! Solve the 9 by 9 triangular system for the coefficients.
!

        DO IB = 1, 9
            I = 10-IB
            T = 0.0E+00_R8
            DO J = I+1, 9
                T = T + B(J,I)*A(J,K)
            END DO
            A(I,K) = (B(10,I)-T)/B(I,I)
        END DO
!
! Scale the coefficients to adjust for the column scaling.
!
        A(1:6,K) = A(1:6,K) / AVSQ
        A(7,K) = A(7,K)/AV
        A(8,K) = A(8,K)/AV
        A(9,K) = A(9,K)/AV
!
! Unmark K and the elements of NPTS.
!
        LNEXT(K) = -LNEXT(K)
        DO I = 1, LNP
            NP = NPTS(I)
            LNEXT(NP) = -LNEXT(NP)
        END DO
    END DO
!
! No errors encountered.
!
    XYZMIN(1:3) = XYZMN(1:3)
    XYZDEL(1:3) = XYZDL(1:3)
    RMAX = SQRT (RSMX)
    IER = 0
    RETURN
  END SUBROUTINE QSHEP3
!  
!=========================================================================
!  
  SUBROUTINE STORE3 (N, X, Y, Z, NR, LCELL, LNEXT, XYZMIN, XYZDEL, IER)
!
! STORE3 sets up a data structure for N scattered nodes in 3D.
!
! Discussion:
!
!   Given a set of N arbitrarily distributed nodes in three-space, 
!   this subroutine creates a data structure for a cell-based method of 
!   solving closest-point problems. The smallest box containing the nodes 
!   is partitioned into an NR by NR by NR uniform grid of cells, and 
!   nodes are associated with cells. In particular, the data structure
!   stores the indices of the nodes contained in each cell. For a 
!   uniform random distribution of nodes, the nearest node to an 
!   arbitrary point can be determined in constant expected time.
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT
!   N, integer, the number of nodes.  N >= 2.
!
!   X(N), Y(N), Z(N), real, the coordinates of the nodes.
!
!   NR, integer, the number of rows, columns, and planes in the
!   grid. The cell density (average number of nodes per cell) is 
!   D = N/(NR**3). A recommended value, based on empirical evidence, 
!   is D = 3, so NR = (N/3)**(1/3). NR >= 1.
!
!  OUTPUT
!   LCELL(NR,NR,NR), integer, a cell array such that 
!   LCELL(I,J,K) contains the index (for X, Y, and Z) of the 
!   first node (node with smallest index) in cell (I,J,K), or 
!   LCELL(I,J,K) = 0 if no nodes are contained in the cell. 
!   The corner of cell (I,J,K) which is farthest from the box 
!   corner defined by XYZMIN has coordinates XMIN+I*DX, 
!   YMIN+J*DY, ZMIN+K*DZ), where (XMIN, YMIN, ZMIN) are 
!   the elements of XYZMIN. LCELL is not defined if IER /= 0.
!
!   LNEXT(N), integer, next-node indices such that
!   LNEXT(L) contains the index of the next node in the cell
!   which contains node L, or LNEXT(L) = L if L is the last 
!   node in the cell for L = 1,...,N. (The nodes contained
!   in a cell are ordered by their indices.)
!
!     If, for example, cell (I,J,K) contains nodes
!     2, 3, and 5 (and no others), then LCELL(I,J,K) = 2, 
!     LNEXT(2) = 3, LNEXT(3) = 5, and LNEXT(5) = 5.  
!     LNEXT is not defined if IER /= 0.
!
!   XYZMIN(3), real, the minimum nodal coordinates
!   XMIN, YMIN, and ZMIN (in that order) unless IER = 1.  
!   The opposite corner of the box defined by the nodes is
!   (XMIN+NR*DX, YMIN+NR*DY, ZMIN+NR*DZ).
!
!   XYZDEL(3), real, the dimensions of the cells 
!   unless IER = 1. XYZDEL(1) = (XMAX-XMIN)/NR, 
!                   XYZDEL(2) = (YMAX-YMIN)/NR,
!               and XYZDEL(3) = (ZMAX-ZMIN)/NR, 
!   where XMIN, XMAX, YMIN, YMAX, ZMIN, and ZMAX are the
!   extrema of X, Y, and Z.
!
!   IER, integer, error indicator.
!     0, if no errors were encountered.
!     1, if N < 2 or NR < 1.
!     2, if a component of XYZDEL is not positive.
!

    INTEGER :: I, IER, J, K, L, LB, LL, N, NN, NR, NNR, NP1
    INTEGER, DIMENSION (N) :: LNEXT            
    INTEGER, DIMENSION (NR,NR,NR) :: LCELL     

    REAL(KIND=R8) :: DELX, DELY, DELZ, XMN, XMX, YMN, YMX, ZMN, ZMX
    REAL(KIND=R8), DIMENSION (N) :: X                    
    REAL(KIND=R8), DIMENSION (3) :: XYZDEL, XYZMIN       
    REAL(KIND=R8), DIMENSION (N) :: Y, Z                 

    NN = N
    NNR = NR
    IF (NN < 2 .OR. NNR < 1) THEN
        IER = 1
        RETURN
    END IF
!
! Compute the dimensions of the box containing the nodes.
!
    XMN = MINVAL (X(1:NN))
    XMX = MAXVAL (X(1:NN))
    YMN = MINVAL (Y(1:NN))
    YMX = MAXVAL (Y(1:NN))
    ZMN = MINVAL (Z(1:NN))
    ZMX = MAXVAL (Z(1:NN))
    XYZMIN(1) = XMN
    XYZMIN(2) = YMN
    XYZMIN(3) = ZMN
!
! Compute cell dimensions and test for zero area.
!
    DELX = (XMX-XMN)/REAL(NNR,KIND=R8)
    DELY = (YMX-YMN)/REAL(NNR,KIND=R8)
    DELZ = (ZMX-ZMN)/REAL(NNR,KIND=R8)
    XYZDEL(1) = DELX
    XYZDEL(2) = DELY
    XYZDEL(3) = DELZ
    IF (DELX == 0.0E+00_R8 .OR. DELY == 0.0E+00_R8 .OR. &
          DELZ == 0.0E+00_R8) THEN
        IER = 2
        RETURN
    END IF
!
! Initialize LCELL.
!
    LCELL(1:NNR,1:NNR,1:NNR) = 0
!
! Loop on nodes, storing indices in LCELL and LNEXT.
!
    NP1 = NN + 1
    DO LL = 1, NN
        LB = NP1 - LL
        I = INT((X(LB)-XMN)/DELX) + 1
        IF (I > NNR) I = NNR
        J = INT((Y(LB)-YMN)/DELY) + 1
        IF (J > NNR ) J = NNR
        K = INT((Z(LB)-ZMN)/DELZ) + 1
        IF (K > NNR) K = NNR
        L = LCELL(I,J,K)
        LNEXT(LB) = L
        IF (L == 0) LNEXT(LB) = LB
        LCELL(I,J,K) = LB
    END DO
    IER = 0
    RETURN
  END SUBROUTINE STORE3
!  
!=========================================================================
!  
  SUBROUTINE GETNP3 (N, PX, PY, PZ, X, Y, Z, NR, LCELL, LNEXT, XYZMIN, &
    XYZDEL, NP, DSQ)
!
! GETNP3 finds the closest node to a given point.
!
! Discussion:
!
!   Given a set of N nodes and the data structure defined in
!   subroutine STORE3, this subroutine uses the cell method to
!   find the closest unmarked node, NP, to a specified point P
!   (PX,PY,PZ).
!
!   Node NP is then marked by setting LNEXT(NP) to -LNEXT(NP).  
!   (A node is marked if and only if the corresponding LNEXT element 
!   is negative.  The absolute values of LNEXT elements,
!   however, must be preserved.)  
!   Thus, the closest M nodes to P may be determined by a sequence
!   of M calls to this routine. Note that if the nearest neighbor to
!   node K is to be determined (PX = X(K), PY = Y(K), and PZ = Z(K)), 
!   then node K should be marked before the call to this routine.
!
!   The search is begun in the cell containing (or closest
!   to) node P and proceeds outward in box-shaped layers until all
!   cells which contain points within distance R of node P have
!   been searched, where R is the distance from node P to the first
!   unmarked node encountered (infinite if no unmarked nodes
!   are present).
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT
!   PX, PY, PZ, real, the coordinates of the point P whose 
!   nearest unmarked neighbor is to be found.
!
!   X(N), Y(N), Z(N), real, the coordinates of the nodes.
!
!   NR, integer, the number of rows, columns, and planes in the cell
!   grid. NR >= 1.
!
!   LCELL(NR,NR,NR), integer, nodal indices associated with cells.
!
!   LNEXT(N), integer, next-node indices (or their negatives). May have
!   a value negated upon return.
!
!   XYZMIN(3), XYZDEL(3), real, minimum nodal coordinates and cell 
!   dimensions, respectively. XYZDEL elements must be positive.
!
!  OUTPUT
!   NP, integer, index of the nearest unmarked node to P, or 0 
!   if all nodes are marked or NR < 1 or an element of XYZDEL is not 
!   positive. LNEXT(NP) < 0 if NP /= 0.
!
!   DSQ, real, squared Euclidean distance between P and node
!   NP, or 0 if NP = 0.
!

    INTEGER :: I, I0, I1, I2, IMAX, IMIN, J, J0, J1, J2, JMAX, &
          JMIN, K, K0, K1, K2, KMAX, KMIN, L, LMIN, LN, N, NP, NR
    INTEGER, DIMENSION (N) :: LNEXT
    INTEGER, DIMENSION (NR,NR,NR) :: LCELL
  
    REAL(KIND=R8):: DELX, DELY, DELZ, DSQ, DX, DY, DZ, PX, PY, &
          PZ, R, RSMIN, RSQ, XP, YP, ZP
    REAL(KIND=R8), DIMENSION (N) :: X
    REAL(KIND=R8), DIMENSION (3) :: XYZDEL, XYZMIN 
    REAL(KIND=R8), DIMENSION (N) :: Y, Z    
    
    LOGICAL FIRST

    XP = PX
    YP = PY
    ZP = PZ
    DX = XYZDEL(1)
    DY = XYZDEL(2)
    DZ = XYZDEL(3)
!
! Test for invalid input parameters.
!
    IF (NR < 1 .OR. DX <= 0.0E+00_R8 .OR. DY <= 0.0E+00_R8 & 
          .OR. DZ <= 0.0E+00_R8) THEN
        NP = 0
        DSQ = 0.0E+00_R8
        RETURN
    END IF
!
! Initialize parameters 
!
! FIRST = TRUE iff the first unmarked node has yet to be encountered,
!   IMIN,...,KMAX = cell indices defining the range of the search,
!   DELX, DELY, DELZ = PX-XYZMIN(1), PY-XYZMIN(2), and PZ-XYZMIN(3),
!   I0,J0,K0 = cell containing or closest to P,
!   I1,...,K2 = cell indices of the layer whose intersection
!   with the range defined by IMIN,...,KMAX is
!   currently being searched.
!
    FIRST = .TRUE.
    IMIN = 1
    IMAX = NR
    JMIN = 1
    JMAX = NR
    KMIN = 1
    KMAX = NR
    DELX = XP - XYZMIN(1)
    DELY = YP - XYZMIN(2)
    DELZ = ZP - XYZMIN(3)
    I0 = INT(DELX/DX) + 1
    IF (I0 < 1) I0 = 1
    IF (I0 > NR) I0 = NR
    J0 = INT (DELY / DY) + 1
    IF (J0 < 1) J0 = 1
    IF (J0 > NR) J0 = NR
    K0 = INT(DELZ/DZ) + 1
    IF (K0 < 1) K0 = 1
    IF (K0 > NR) K0 = NR
    I1 = I0
    I2 = I0
    J1 = J0
    J2 = J0
    K1 = K0
    K2 = K0
!
! Outer loop on layers, inner loop on layer cells, excluding
! those outside the range (IMIN,IMAX) X (JMIN,JMAX) X (KMIN,KMAX).
!
    MAIN: DO
        LOOP_K: DO K = K1, K2
            IF (K > KMAX) EXIT 
            IF (K < KMIN) CYCLE LOOP_K
            LOOP_J: DO J = J1, J2
                IF (J > JMAX) EXIT
                IF (J < JMIN) CYCLE LOOP_J
                LOOP_I: DO I = I1, I2
                    IF (I > IMAX) EXIT
                    IF (I < IMIN) CYCLE LOOP_I
                    IF (K /= K1  .AND.  K /= K2  .AND. J /= J1  .AND.  &
                          J /= J2  .AND. I /= I1  .AND.  I /= I2) CYCLE LOOP_I
!
! Search cell (I,J,K) for unmarked nodes L.
!
                    L = LCELL(I,J,K)
                    IF (L == 0) CYCLE LOOP_I
!
! Loop on nodes in cell (I,J,K).
!
                    CELL_LOOP: DO
                        LN = LNEXT(L)
                        IF (LN < 0) THEN 
                            IF (ABS(LN) == L) CYCLE LOOP_I
                            L = ABS(LN)
                            CYCLE CELL_LOOP
                        END IF
!
! Node L is not marked.
!
                        RSQ = (X(L)-XP)**2 + (Y(L)-YP)**2 + (Z(L)-ZP)**2
                        IF (.NOT. FIRST) THEN
!
! Update LMIN and RSMIN.
!
                            IF (RSQ < RSMIN) THEN
                                LMIN = L
                                RSMIN = RSQ
                            END IF
!
! Test for termination of loop on nodes in cell (i,j,k).
!
                            IF ( ABS(LN) == L ) CYCLE LOOP_I
                            L = ABS(LN)
                            CYCLE CELL_LOOP
                        END IF
!
! Node L is the first unmarked neighbor of node P encountered.
! Initialize LMIN to the current candidate for NP, and
! RSMIN to the squared distance from node P to node LMIN. 
! IMIN, IMAX, JMIN, JMAX, KMIN, and KMAX are updated to define
! the smallest rectangle containing a sphere of radius
! R = SQRT(RSMIN) centered at P, and contained in 
!(1,NR) X (1,NR) X (1,NR) (except that, if P is outside the
! box defined by the nodes, it is possible that IMIN > NR or 
! IMAX < 1, etc.). FIRST is reset to false.
!
                        LMIN = L
                        RSMIN = RSQ
                        R = SQRT(RSMIN)
                        IMIN = INT((DELX-R)/DX) + 1
                        IF (IMIN < 1) IMIN = 1
                        IMAX = INT((DELX+R)/DX) + 1
                        IF (IMAX > NR) IMAX = NR
                        JMIN = INT((DELY-R)/DY) + 1
                        IF (JMIN < 1) JMIN = 1
                        JMAX = INT((DELY+R)/DY) + 1
                        IF (JMAX > NR) JMAX = NR
                        KMIN = INT((DELZ-R)/DZ) + 1
                        IF (KMIN < 1) KMIN = 1
                        KMAX = INT((DELZ+R)/DZ) + 1
                        IF (KMAX > NR) KMAX = NR
                        FIRST = .FALSE.
                        IF (ABS(LN) == L) CYCLE LOOP_I
                        L = ABS(LN)
                        CYCLE CELL_LOOP
!
!  Test for node L closer than node LMIN to node P.
!
                    END DO CELL_LOOP
                END DO LOOP_I
            END DO LOOP_J
        END DO LOOP_K
!
! Test for termination of loop on cell layers.
!
        IF (I1 <= IMIN  .AND.  I2 >= IMAX  .AND. &
              J1 <= JMIN  .AND.  J2 >= JMAX  .AND. &
              K1 <= KMIN  .AND.  K2 >= KMAX) EXIT  
        I1 = I1 - 1
        I2 = I2 + 1
        J1 = J1 - 1
        J2 = J2 + 1
        K1 = K1 - 1
        K2 = K2 + 1
        CYCLE MAIN
    END DO MAIN
!
! Unless no unmarked nodes were encountered, LMIN is the
! closest unmarked node to node P.
!
    IF (.NOT. FIRST) THEN
        NP = LMIN
        DSQ = RSMIN
        LNEXT(LMIN) = -LNEXT(LMIN)
    ELSE
        NP = 0
        DSQ = 0.0E+00_R8
    END IF
    RETURN
  END SUBROUTINE GETNP3
!  
!=========================================================================
!  
  SUBROUTINE SETUP3 (XK, YK, ZK, FK, XI, YI, ZI, FI, S1, S2, R, ROW)
!
! SETUP3 sets up the weighted least-squares fit of the data.
!
! Discussion:
!   This routine sets up the I-th row of an augmented regression matrix 
!   for a weighted least-squares fit of a quadratic function Q(X,Y,Z) 
!   to a set of data values F, where Q(XK,YK,ZK) = FK.  
!
!   The first 6 columns (quadratic terms) are scaled by 1/S2, and 
!   columns 7, 8, and 9 (linear terms) are scaled by 1/S1.  
!   The weight is (R-D)/(R*D) if R > D, and 0 if R <= D, 
!   where D is the distance between nodes I and K.
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT
!   XK, YK, ZK, FK, real, coordinates and data value at node K
!    (interpolated by Q).
!
!   XI, YI, ZI, FI, real, coordinates and data value at node I.
!
!   S1, S2, real, reciprocals of the scale factors.
!
!   R, real, radius of influence about node K defining the weight.
!
!  OUTPUT
!   real ROW(10), a row of the augmented regression matrix.
!
! Local variables:
!
!    D =  Distance between nodes K and I.
!
!    W =  Weight associated with a row.
!
!    W1 = W/S1.
!
!    W2 = W/S2.
!

    REAL(KIND=R8):: D, DX, DXSQ, DY, DYSQ, DZ, DZSQ, FI, FK, R, S1, S2, &
          W, W1, W2, XI, XK, YI, YK, ZI, ZK
    REAL(KIND=R8), DIMENSION(10) :: ROW
    
    DX = XI - XK
    DY = YI - YK
    DZ = ZI - ZK
    DXSQ = DX*DX
    DYSQ = DY*DY
    DZSQ = DZ*DZ
    D = SQRT (DXSQ + DYSQ + DZSQ)

    IF (D <= 0.0E+00_R8 .OR. D >= R) THEN
        ROW(1:10) = 0.0E+00_R8
        RETURN
    END IF
    W = (R - D) / R / D
    W1 = W/S1
    W2 = W/S2
    ROW(1) = DXSQ*W2
    ROW(2) = DX*DY*W2
    ROW(3) = DYSQ*W2
    ROW(4) = DX*DZ*W2
    ROW(5) = DY*DZ*W2
    ROW(6) = DZSQ*W2
    ROW(7) = DX*W1
    ROW(8) = DY*W1
    ROW(9) = DZ*W1
    ROW(10) = (FI - FK)*W
    RETURN
  END SUBROUTINE SETUP3
!  
!=========================================================================
!  
  SUBROUTINE QS3GRD (PX, PY, PZ, N, X, Y, Z, F, NR, LCELL, &
        LNEXT, XYZMIN, XYZDEL, RMAX, RSQ, A, Q, QX, QY, QZ, IER)
!
! QS3GRD computes the value and gradient of the interpolant function.
!
! Discussion:
!
! This subroutine computes the value and gradient at (PX,PY,PZ) of 
! the interpolatory function Q defined in the subroutine QSHEP3.  
!
! Q(X,Y,Z) is a weighted sum of quadratic nodal functions.
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT
!   PX, PY, PZ, real, the point P at which Q and its partials are 
!   to be evaluated.
!
!   N, integer, the number of nodes and data values defining Q.
!   N >= 10.
!
!   X(N), Y(N), Z(N), F(N), real, the node coordinates and
!   data values interpolated by Q.
!
!   NR, integer, the number of rows, columns and planes in the cell
!   grid. Refer to STORE3. NR >= 1.
!
!   LCELL(NR,NR,NR), integer, nodal indices associated with cells.  
!   Refer to STORE3.
!
!   LNEXT(N), integer, the next-node indices. Refer to STORE3.
!
!   XYZMIN(3), XYZDEL(3), real, the minimum nodal coordinates and 
!   cell dimensions, respectively. XYZDEL elements must be positive.  
!   Refer to STORE3.
!
!   RMAX, real, the square root of the largest element in RSQ,
!   the maximum radius.
!
!   RSQ(N), real, the squared radii which enter into the weights 
!   defining Q.
!
!   A(9,N), real, the coefficients for the nodal functions defining Q.
!
!  OUTPUT
!   Q, real, the value of Q at (PX,PY,PZ) unless IER == 1, in
!   which case no values are returned.
!
!   QX, QY, QZ, real, the first partial derivatives of Q at
!   (PX,PY,PZ) unless IER == 1.
!
!   IER, integer, error indicator
!      0, if no errors were encountered.
!      1, if N, NR, XYZDEL, or RMAX are invalid.
!      2, if no errors were encountered but (PX.PY.PZ) is not within the 
!         radius R(K) for any node K (and thus Q = QX = QY = QZ = 0).
!

    INTEGER :: I, IER, IMAX, IMIN, J, JMAX, JMIN, K, KMAX, &
          KMIN, L, LP, N, NR
    INTEGER, DIMENSION (N) :: LNEXT
    INTEGER, DIMENSION (NR,NR,NR) :: LCELL
    
    REAL(KIND=R8):: DELX, DELY, DELZ, DS, DX, DXSQ, DY, DYSQ, DZ, DZSQ, &
          PX, PY, PZ, Q, QL, QLX, QLY, QLZ, QX, QY, QZ, RD, RDS, RMAX, RS, &
          SW, SWQ, SWQX, SWQY, SWQZ, SWS, SWX, SWY, SWZ, T, W, WX, WY, WZ, &
          XMIN, XP, YMIN, YP, ZMIN, ZP
    REAL(KIND=R8), DIMENSION (N) :: F, RSQ, X
    REAL(KIND=R8), DIMENSION (3) :: XYZDEL, XYZMIN 
    REAL(KIND=R8), DIMENSION (N) :: Y, Z
    REAL(KIND=R8), DIMENSION (9,N) :: A
 
    XP = PX
    YP = PY
    ZP = PZ
    XMIN = XYZMIN(1) 
    YMIN = XYZMIN(2)
    ZMIN = XYZMIN(3)
    DX = XYZDEL(1)
    DY = XYZDEL(2)
    DZ = XYZDEL(3)

    IF (N < 10  .OR.  NR < 1  .OR.  DX <= 0.0E+00_R8 &
          .OR.  DY <= 0.0E+00_R8  .OR.  DZ <= 0.0E+00_R8  .OR. &
          RMAX < 0.0E+00_R8) THEN
        IER = 1
        RETURN
    END IF
!
! Set IMIN, IMAX, JMIN, JMAX, KMIN, and KMAX to cell indices
! defining the range of the search for nodes whose radii
! include P.  The cells which must be searched are those
! intersected by (or contained in) a sphere of radius RMAX
! centered at P.
!
    IMIN = INT((XP-XMIN-RMAX)/DX) + 1
    IMIN = MAX (IMIN, 1)
    IMAX = INT((XP-XMIN+RMAX)/DX) + 1
    IMAX = MIN (IMAX, NR)
    JMIN = INT((YP-YMIN-RMAX)/DY) + 1
    JMIN = MAX (JMIN, 1)
    JMAX = INT((YP-YMIN+RMAX)/DY) + 1
    JMAX = MIN (JMAX, NR)
    KMIN = INT((ZP-ZMIN-RMAX)/DZ) + 1
    KMIN = MAX (KMIN, 1)
    KMAX = INT((ZP-ZMIN+RMAX)/DZ) + 1
    KMAX = MIN (KMAX, NR)
!
! Test for no cells within the sphere of radius RMAX.
!
    IF (IMIN > IMAX .OR. JMIN > JMAX .OR. KMIN > KMAX) THEN
        Q = 0.0E+00_R8
        QX = 0.0E+00_R8
        QY = 0.0E+00_R8
        QZ = 0.0E+00_R8
        IER = 2
        RETURN
    END IF
!
! Q = SWQ/SW = sum(W(L)*Q(L))/sum(W(L)) where the sum is
! from L = 1 to N, Q(L) is the quadratic nodal function,
! and W(L) = ((R-D)+/(R*D))**2 for radius R(L) and distance D(L).  
! Thus
!   QX = (SWQX*SW - SWQ*SWX)/SW**2
!   QY = (SWQY*SW - SWQ*SWY)/SW**2
!   QZ = (SWQZ*SW - SWQ*SWZ)/SW**2,
! where SWQX and SWX are partial derivatives with respect
! to X of SWQ and SW, respectively. SWQY, SWY, SWQZ, and
! SWZ are defined similarly.
!
    SW = 0.0E+00_R8
    SWX = 0.0E+00_R8
    SWY = 0.0E+00_R8
    SWZ = 0.0E+00_R8
    SWQ = 0.0E+00_R8
    SWQX = 0.0E+00_R8
    SWQY = 0.0E+00_R8
    SWQZ = 0.0E+00_R8
!
! Outer loop on cells (I,J,K).
!
    DO K = KMIN, KMAX
        DO J = JMIN, JMAX
            DO I = IMIN, IMAX
                L = LCELL(I,J,K)
                IF (L == 0) THEN
                    CYCLE
                END IF
!
! Inner loop on nodes L.
!
                DO
                    DELX = XP - X(L)
                    DELY = YP - Y(L)
                    DELZ = ZP - Z(L)
                    DXSQ = DELX*DELX
                    DYSQ = DELY*DELY
                    DZSQ = DELZ*DELZ
                    DS = DXSQ + DYSQ + DZSQ
                    RS = RSQ(L)

                    IF (DS < RS) THEN
                        IF (DS == 0.0E+00_R8) THEN
                            Q = F(L)
                            QX = A(7,L)
                            QY = A(8,L)
                            QZ = A(9,L)
                            IER = 0
                            RETURN
                        END IF
                        RDS = RS*DS
                        RD = SQRT(RDS)
                        W = (RS+DS-RD-RD)/RDS
                        T = 2.0E+00_R8 *(RD-RS)/(DS*RDS)
                        WX = DELX*T
                        WY = DELY*T
                        WZ = DELZ*T
                        QLX = 2.0E+00_R8 *A(1,L)*DELX + A(2,L)*DELY + A(4,L)*DELZ
                        QLY = A(2,L)*DELX + 2.0E+00_R8 * A(3,L)*DELY + A(5,L)*DELZ
                        QLZ = A(4,L)*DELX + A(5,L)*DELY + 2.0E+00_R8 * A(6,L)*DELZ
                        QL = (QLX*DELX + QLY*DELY + QLZ*DELZ) / 2.0E+00_R8 + &
                        A(7,L)*DELX + A(8,L)*DELY + A(9,L)*DELZ + F(L)
                        QLX = QLX + A(7,L)
                        QLY = QLY + A(8,L)
                        QLZ = QLZ + A(9,L)
                        SW = SW + W
                        SWX = SWX + WX
                        SWY = SWY + WY
                        SWZ = SWZ + WZ
                        SWQ = SWQ + W*QL
                        SWQX = SWQX + WX*QL + W*QLX
                        SWQY = SWQY + WY*QL + W*QLY
                        SWQZ = SWQZ + WZ*QL + W*QLZ
                    END IF
                    LP = L
                    L = LNEXT(LP)
                    IF ( L == LP ) THEN
                        EXIT
                    END IF
                END DO
            END DO
        END DO
    END DO
!
! SW = 0 iff node P is not within the radius R(L) for any node L.
!
    IF (SW /= 0.0E+00_R8) THEN
        Q = SWQ/SW
        SWS = SW*SW
        QX = (SWQX*SW - SWQ*SWX)/SWS
        QY = (SWQY*SW - SWQ*SWY)/SWS
        QZ = (SWQZ*SW - SWQ*SWZ)/SWS
        IER = 0
!
! No cells contain a point within RMAX of node P, or
! SW = 0 and thus DS >= RSQ(L) for all L.
!
    ELSE
        Q = 0.0E+00_R8
        QX = 0.0E+00_R8
        QY = 0.0E+00_R8
        QZ = 0.0E+00_R8
        IER = 2
    END IF
    RETURN
  END SUBROUTINE QS3GRD
!  
!=========================================================================
!  
  FUNCTION QS3VAL (PX, PY, PZ, N, X, Y, Z, F, NR, LCELL, LNEXT, &
    XYZMIN, XYZDEL, RMAX, RSQ, A)
!
! QS3VAL evaluates the interpolant function Q(X,Y,Z) 
! created by QSHEP3.
!
! Discussion:
!
!  This function returns the value Q(PX,PY,PZ) where Q is
!  the weighted sum of quadratic nodal functions defined in
!  subroutine QSHEP3. QS3GRD may be called to compute a
!  gradient of Q along with the value, or to test for errors.
!
!  This function should not be called if a nonzero error flag was
!  returned by QSHEP3.
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Updated to FORTRAN 95 by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
! 
! Modified:   
!   15 December 2005  
!
! Parameters:
!
!  INPUT
!   PX, PY, PZ, real, the point P at which Q is to be evaluated.
!
!   N, integer, the number of nodes and data values defining Q.
!   N >= 10.
!
!   X(N), Y(N), Z(N), F(N), real, the node coordinates
!   and data values interpolated by Q.
!
!   NR, integer, the number of rows, columns and planes in the cell
!   grid. Refer to STORE3. NR >= 1.
!
!   LCELL(NR,NR,NR), integer, the nodal indices associated with cells.  
!   Refer to STORE3.
!
!   LNEXT(N), integer, the next-node indices. Refer to STORE3.
!
!   XYZMIN(3), XYZDEL(3), real, the minimum nodal coordinates and 
!   cell dimensions, respectively. XYZDEL elements must be positive.  
!   Refer to STORE3.
!
!   RMAX, real, the square root of the largest element in RSQ,
!   the maximum radius.
!
!   RSQ(N), real, the squared radii which enter into the weights 
!   defining Q.
!
!   A(9,N), real, the coefficients for the nodal functions defining Q.
!
!  OUTPUT
!   QS3VAL, real, the function value Q(PX,PY,PZ) unless N, NR,
!   XYZDEL, or RMAX are invalid, in which case the value 0 is returned.
!

    INTEGER :: I, IMAX, IMIN, J, JMAX, JMIN, K, KMAX, KMIN, &
          L, LP, N, NR
    INTEGER, DIMENSION (N) :: LNEXT
    INTEGER, DIMENSION (NR,NR,NR) :: LCELL

   REAL(KIND=R8):: DELX, DELY, DELZ, DS, DX, DXSQ, DY, DYSQ, DZ, &
         DZSQ, PX, PY, PZ, QS3VAL, RD, RDS, RMAX, RS, SW, SWQ, W,  &
         XMIN, XP, YMIN, YP, ZMIN, ZP
    REAL(KIND=R8), DIMENSION (N) :: F, RSQ, X
    REAL(KIND=R8), DIMENSION (3) :: XYZDEL, XYZMIN 
    REAL(KIND=R8), DIMENSION (N) :: Y, Z
    REAL(KIND=R8), DIMENSION (9,N) :: A
  
    XP = PX
    YP = PY
    ZP = PZ
    XMIN = XYZMIN(1)
    YMIN = XYZMIN(2)
    ZMIN = XYZMIN(3)
    DX = XYZDEL(1)
    DY = XYZDEL(2)
    DZ = XYZDEL(3)

    IF (N < 10  .OR.  NR < 1  .OR.  DX <= 0.0 &
           .OR.  DY <= 0.0  .OR.  DZ <= 0.0  .OR. &
           RMAX < 0.0 ) THEN
        QS3VAL = 0.0E+00
        RETURN
    END IF
!
! Set IMIN, IMAX, JMIN, JMAX, KMIN, and KMAX to cell indices
! defining the range of the search for nodes whose radii
! include node P. The cells which must be searched are those
! intersected by (or contained in) a sphere of radius RMAX
! centered at node P.
!
    IMIN = INT((XP-XMIN-RMAX)/DX) + 1
    IMIN = MAX (IMIN, 1)
    IMAX = INT((XP-XMIN+RMAX)/DX) + 1
    IMAX = MIN (IMAX, NR)
    JMIN = INT((YP-YMIN-RMAX)/DY) + 1
    JMIN = MAX (JMIN, 1)
    JMAX = INT((YP-YMIN+RMAX)/DY) + 1
    JMAX = MIN (JMAX, NR)
    KMIN = INT((ZP-ZMIN-RMAX)/DZ) + 1
    KMIN = MAX (KMIN, 1)
    KMAX = INT((ZP-ZMIN+RMAX)/DZ) + 1
    KMAX = MIN (KMAX, NR)
!
! Test for no cells within the sphere of radius RMAX.
!
    IF (IMIN > IMAX .OR. JMIN > JMAX .OR. KMIN > KMAX) THEN
        QS3VAL = 0.0E+00_R8
        RETURN
    END IF
!
! Accumulate weight values in SW and weighted nodal function
! values in SWQ.  The weights are W(L) = ((R-D)+/(R*D))**2
! for R**2 = RSQ(L) and D = distance between node P and node L.
!
    SW = 0.0E+00_R8
    SWQ = 0.0E+00_R8
!
! Outer loop on cells (I,J,K).
!
    DO K = KMIN, KMAX
        DO J = JMIN, JMAX
            DO I = IMIN, IMAX
                L = LCELL(I,J,K)
                IF (L == 0) THEN
                    CYCLE
                END IF
!
! Inner loop on nodes L.
!
                DO
                    DELX = XP - X(L)
                    DELY = YP - Y(L)
                    DELZ = ZP - Z(L)
                    DXSQ = DELX*DELX
                    DYSQ = DELY*DELY
                    DZSQ = DELZ*DELZ
                    DS = DXSQ + DYSQ + DZSQ
                    RS = RSQ(L)
                    IF (DS < RS) THEN
                        IF (DS == 0.0E+00_R8) THEN
                            QS3VAL = F(L)
                            RETURN
                        END IF
                        RDS = RS*DS
                        RD = SQRT(RDS)
                        W = (RS+DS-RD-RD)/RDS
                        SW = SW + W
                        SWQ = SWQ + W *( A(1,L)*DXSQ + A(2,L)*DELX*DELY + &
                                   A(3,L)*DYSQ + A(4,L)*DELX*DELZ + &
                                   A(5,L)*DELY*DELZ + A(6,L)*DZSQ + &
                                   A(7,L)*DELX + A(8,L)*DELY + &
                                   A(9,L)*DELZ + F(L) )

                    END IF
                    LP = L
                    L = LNEXT(LP)
                    IF (L == LP) THEN
                        EXIT
                    END IF
                END DO
            END DO
        END DO
    END DO
!
! SW = 0 iff P is not within the radius R(L) for any node L.
!
    IF (SW == 0.0E+00_R8) THEN
        QS3VAL = 0.0E+00_R8
    ELSE
        QS3VAL = SWQ / SW
    END IF
    RETURN
  END FUNCTION QS3VAL
!  
!=========================================================================
!
  SUBROUTINE GIVENS (A, B, C, S)
!
! GIVENS constructs a Givens plane rotation.
!
! The transformation has the form of a 2 by 2 matrix G(C,S):
! (  C  S)
! (- S  C)
!
! where C*C + S*S = 1, which zeroes the second entry of the
! the column vector (A, B) when C and S are properly chosen.
! A call to GIVENS is normally followed by a call to ROTATE
! which computes the product of G(C,S) with a 2 by N matrix.
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Modified by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
!
! Modified:
!   15 November 2005
!
! Parameters:
!
!   Input/output, real A, B.
!
!   On input, A and B define the 2-vector whose second entry (B) is
!   to be annihilated by a Givens rotation.
!
!   On output, A has been overwritten by a value
!     R = +/- SQRT ( A*A + B*B )
!     and B has been overwritten by a value Z which allows C
!     and S to be recovered as:
!
!       if | Z | <= 1, then
!         C = SQRT (1 - Z*Z),
!         S = Z
!       else if | Z | > 1 then
!         C = 1 / Z,
!         S = SQRT (1 - C*C).
!
!     Output, real C, S, the components of the Givens transformation,
!     which may be computed by:
!       C = +/- A / SQRT (A*A + B*B)
!       S = +/- B / SQRT (A*A + B*B)
!
! Local parameters:
!
!   R = C*A + S*B = +/-SQRT(A*A+B*B)
!   U,V = variables used to scale A and B for computing R
!
!   ABS(A) > ABS(B)
!
!   Note that R has the sign of A, C > 0, and S has
!   SIGN(A)*SIGN(B).
!
    DOUBLE PRECISION :: A, B, C, R, S, U, V

    IF (ABS (A) > ABS (B)) THEN
      U = 2.0E+00 * A
      V = B / U
      R = SQRT ( 0.25E+00 + V * V ) * U
      C = A / R
      S = 2.0E+00 * V * C
      B = S
      A = R
!
! ABS(A) <= ABS(B)
! Store R in A.
! Note that R has the sign of B, S > 0, and C has SIGN(A)*SIGN(B).
!
      ELSE IF (B /= 0.0E+00) THEN
        U = 2.0E+00 * B
        V = A / U
        A = SQRT (0.25E+00 + V * V) * U
        S = B / A
        C = 2.0E+00 * V * S
        IF (C /= 0.0E+00) THEN
          B = 1.0E+00 / C
        ELSE
          B = 1.0E+00
        END IF
!
! A = B = 0.
!
      ELSE
        C = 1.0E+00
        S = 0.0E+00
    END IF
    RETURN
  END
!
!=========================================================================
!
  SUBROUTINE ROTATE ( N, C, S, X, Y )
!
! ROTATE applies a Givens rotation.
!
! The rotation has the form:
!
! (  C  S)
! (- S  C)
!
! and is essentially applied to a 2 by N matrix:
! (X(1) X(2) ... X(N))
! (Y(1) Y(2) ... Y(N))
!
! Author:
!   Robert Renka
!   University of North Texas
!
! Modified by:
!   Manjula Iyer
!   Virginia Polytechnic Institute and State University
!
! Modified:
!   15 November 2005
!
! Parameters:
!
!   Input, integer N, the dimension of the vectors.
!
!   Input, real C, S, the cosine and sine entries of the Givens
!   rotation matrix. These may be determined by subroutine GIVENS.
!
!   Input/output, real X(N), Y(N), the rotated vectors.
!

    INTEGER I, N
    DOUBLE PRECISION :: C, S, XI, YI
    DOUBLE PRECISION, DIMENSION(N) :: X, Y

    IF (N <= 0) THEN
      RETURN
    ELSE IF (C == 1.0E+00 .AND. S == 0.0E+00) THEN
      RETURN
    END IF

    DO I = 1, N
      XI = X(I)
      YI = Y(I)
      X(I) =   C * XI + S * YI
      Y(I) = - S * XI + C * YI
    END DO
    RETURN
  END


END MODULE QSHEP3D_MOD

!    -*- f95 -*-
! -*- coding: utf-8 -*-
! written by Ralf Biehl at the Forschungszentrum Juelich ,
! Juelich Center for Neutron Science 1 and Institute of Complex Systems 1
!    jscatter is a program to read, analyse and plot data
!    Copyright (C) 2015-2021  Ralf Biehl
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!

! f2py -c fscatter.f95 -m fscatter


module utils
    use typesandconstants
    use pseudorandom
    !$ use omp_lib
    implicit none

contains

subroutine setncpu(ncpu)
    ! set number of cpus used in parallel
    integer, intent(in)           :: ncpu
    integer                       :: num_threads

    num_threads = omp_get_num_procs()
    if (ncpu<0) then
        num_threads=max(num_threads + ncpu,1)
    else if (ncpu>0) then
        num_threads=min(ncpu, num_threads)
    end if
    call omp_set_num_threads(num_threads)

end subroutine setncpu

!function getncpu() result(ncpu)
!    ! get number of cpus used in parallel
!    integer          :: ncpu
!
!    ncpu = omp_get_num_procs()
!end function getncpu


function random_gauss(dim1,dim2) result(rg)
    ! Gaussian random number with center 0 and 1-sigma =1 with shape of (dim1,dim2)
    ! uses Box-Muller transform

    integer, intent(in) :: dim1,dim2
    real(dp), dimension(dim1,dim2) :: r, rg
    integer(dp) :: i
    r=0
    rg=0
    CALL RANDOM_NUMBER(r)
    do i=1,dim1-1,2
        rg(i,:)   = SQRT(-2_dp*LOG(r(i,:))) * COS(2_dp*pi_dp*r(i+1,:))
        rg(i+1,:) = SQRT(-2_dp*LOG(r(i,:))) * SIN(2_dp*pi_dp*r(i+1,:))
    end do
end function random_gauss

function interp(x,y,fy)
    ! linear interpolation of sorted array
    ! if x is out of range the upper or lower boundary value is returned

    real(dp),           intent(in)   :: x(:),y(:),fy(:)
    real(dp), dimension(size(x))    :: interp
    integer                          :: i,j,imax ,jmax

    imax=size(x)
    jmax=size(y)
    do i =1,imax
        if  (x(i)<= y(1)) then
            interp(i)=fy(1)
        else if  (x(i)>=y(jmax)) then
            interp(i)=fy(jmax)
        else
            do j=1, jmax
                if  ( y(j)<=x(i) .and. x(i)<y(j+1) )    exit
            end do
            interp(i)=interp1d_single(y(j),fy(j),y(j+1),fy(j+1),x(i))
        end if
    end do
end function interp

function interp_s(x,y,fy) result(ip2)
    ! single value linear interpolation of sorted array
    ! if x is out of range the upper or lower boundary value is returned

    real(dp),           intent(in)   :: x,y(:),fy(:)
    real(dp)                         :: res(1),ip2

    res=interp([x],y,fy)
    ip2=res(1)

end function interp_s


function interp1d_single(x1,y1,x2,y2,xval)
    ! linear interpolation
    ! xval outside interval are linear extrapolated

    real(dp),intent(in) :: x1,y1,x2,y2,xval
    real(dp) :: frac, interp1d_single
    frac = ( xval - x1 ) / ( x2 - x1 )
    interp1d_single = y1 + frac * ( y2 - y1 )
end function interp1d_single

function fibonaccilatticepointsonsphere(NN, r) result(lattice)
    ! create a Fibonacci lattice with NN*2+1 points on sphere with radius r
    ! returns spherical coordinates r,theta, phi

    integer,  intent(in)                :: NN
    real(dp), intent(in)                :: r

    real(dp), dimension(2*NN+1)         :: n
    integer                             :: i
    real(dp),dimension(2*NN+1,3)        :: lattice

    do i = 1,2*NN+1
        n(i)=(i-NN-1_dp)
    end do

    lattice(:,1)= r
    lattice(:,2)= modulo((2*pi_dp * n / golden_dp) + pi_dp,  2*pi_dp) - pi_dp
    lattice(:,3)= asin(2_dp*n / (2 * NN + 1.)) + pi_dp / 2_dp

end function fibonaccilatticepointsonsphere

function randompointsonsphere(NN, skip, r) result(lattice)
    ! create pseudo random points on sphere with radius r
    ! returns spherical coordinates r,theta, phi
    ! skip is number of points skipped in halton sequence

    integer,  intent(in)            :: NN,skip
    real(dp), intent(in)            :: r

    real(dp), dimension(2,NN)       :: hs
    real(dp), dimension(NN,3)       :: lattice

    hs=halton_sequence(skip,skip+NN-1,2)
    lattice(:,1)= r
    lattice(:,2)= 2*pi_dp*hs(1,:)- pi_dp
    lattice(:,3)= ACOS(2*hs(2,:) - 1)

end function randompointsonsphere

function rphitheta2xyz(rpt) result(xyz)
    ! array transform rpt coordinates to cartesian

    real(dp), intent(in)    :: rpt(:,:)
    real(dp),dimension(size(rpt,1),3) :: xyz

    xyz(:,1)=rpt(:,1)*cos(rpt(:,2))*sin(rpt(:,3))
    xyz(:,2)=rpt(:,1)*sin(rpt(:,2))*sin(rpt(:,3))
    xyz(:,3)=rpt(:,1)*cos(rpt(:,3))

end function rphitheta2xyz

function rphitheta2xyzv(rpt) result(xyz)
    ! vector transform rpt coordinates to cartesian

    real(dp), intent(in)   :: rpt(:)
    real(dp), dimension(3) :: xyz

    xyz(1)=rpt(1)*cos(rpt(2))*sin(rpt(3))
    xyz(2)=rpt(1)*sin(rpt(2))*sin(rpt(3))
    xyz(3)=rpt(1)*cos(rpt(3))

end function rphitheta2xyzv

function xyz2rphitheta(xyz) result(rpt)
    ! array transform cartesian coordinates to rpt

    ! points Nx3
    real(dp), intent(in)    :: xyz(:,:)
    real(dp),dimension(size(xyz,1),3) :: rpt

    rpt(:, 1) = sqrt(sum(xyz**2, dim=2))
    rpt(:, 2) = ATAN2(xyz(:, 2), xyz(:, 1))
    rpt(:, 3) = ATAN2(sqrt(sum(xyz(:, 1:2)**2, dim=2)), xyz(:, 3))

end function xyz2rphitheta

function xyz2rphithetav(xyz) result(rpt)
    ! vector transform cartesian coordinates to rpt

    real(dp), intent(in)    :: xyz(3)
    real(dp),dimension(3)   :: rpt

    rpt(1) = sqrt(sum(xyz**2))
    rpt(2) = ATAN2(xyz(2), xyz(1))
    rpt(3) = ATAN2(sqrt(sum(xyz(1:2)**2)), xyz(3))

end function xyz2rphithetav

function wofz(xy) result(wxy)
    ! The Faddeeva function for complex arguments
    ! vectorized wofz
    complex(dp), intent(in)                        :: xy(:)
    complex(dp),dimension(size(xy))                :: wxy
    integer                                        :: i
    real(dp)                                       :: cx,cy

    do i = 1,size(xy)
        cx = 0_dp
        cy = 0_dp
        call ccperrfr(dreal(xy(i)), dimag(xy(i)), cx, cy)
        wxy(i) = dcmplx(cx,cy)
    end do

end function wofz

function voigt(x, center, fwhm, lg, asym, amplitude) result(val)
    ! Voigt function for peak analysis (normalized)
    ! calc the fwhm in gauss and lorenz to get the final FWHM in the Voigt function with an accuracy of 0.0002.
    ! as given in Olivero, J. J.; R. L. Longbothum (February 1977).
    ! Empirical fits to the Voigt line width: A brief review".
    ! Journal of Quantitative Spectroscopy and Radiative Transfer. 17 (2): 233-236.
    ! doi:10.1016/0022-4073(77)90161-3

    ! x, center, fwhm, Lorenzian/gaussian fraction, symmetry factor, amplitude
    real(dp), intent(in)          :: x(:), center, fwhm, lg, asym, amplitude
    real(dp),dimension(size(x))   :: val
    real(dp)                      :: fw
    real(dp),dimension(size(x))   :: afwhm
    complex(dp),dimension(size(x)):: z,wofzz
    integer                       :: i

    ! init
    val = 0
    fw = 0
    afwhm = 0
    z = 0
    wofzz = 0

    fw = fwhm / (0.5346 * lg + (0.2166 * lg ** 2 + 1) ** 0.5)

    ! the sigmoidal fwhm for asymmetry
    afwhm = 2.0_dp * fw / (1.0_dp + exp(asym * (x - center)))

    ! complex z
    z =  dcmplx((x - center), lg * afwhm / 2.0_dp)
    z = z / sqrt(2.0_dp) / (afwhm / (2.0_dp * sqrt(2.0_dp * ln2)))

    val = amplitude / (afwhm / (2 * sqrt(2.0_dp * ln2))) / sqrt(2.0_dp * pi_dp)

    wofzz = wofz(z)
    do i = 1,size(x)
        val(i)=val(i) * dreal(  wofzz(i)  )
    end do

end function voigt

function sumlhklvoigt(q, qhkl, f2hkl, mhkl,lg, domainsize, asym, dim, c, n, vd, ncpu) result(Z0q)
    ! This calculates the sum over peak shapes in radial structure factor
    ! voigt peak shapes over all hkl peak indices
    real(dp), intent(in)          :: q(:), qhkl(:), f2hkl(:), mhkl(:), lg, domainsize, asym, c, n, vd
    integer, intent(in)           :: dim, ncpu
    real(dp),dimension(size(q))   :: Z0q, temp
    integer                       :: i

    call setncpu(ncpu)

    ! sum lattice factors
    Z0q=0
    !$omp parallel do private(temp)
    do i=1,size(qhkl)
        temp = mhkl(i) * f2hkl(i) * voigt(q, qhkl(i), pi2_dp/domainsize, lg, asym, 1.0_dp)
        !$omp critical
        Z0q = Z0q + temp
        !$omp end critical
    end do
    !$omp end parallel do

    ! normalisations
    Z0q = Z0q *(pi2_dp) ** (dim - 1) * c / n / vd / q ** (dim - 1)

end function sumlhklvoigt

function lhklgauss(q,center,sigma) result(lhkl)
    ! calculates intensities of normalized Gaussian peak in 3 dimensions with width sigma located at center
    ! for given 3D q values

    ! wavevectors Nx3, center and width of peak in each dimension
    real(dp), intent(in) :: q(:,:), center(3),sigma(3)
    ! center shifted q_i, result array
    real(dp)             :: qc(size(q,1)),lhkl(size(q,1))

    qc(:)=q(:,1)-center(1)
    lhkl=exp(-0.5_dp*qc**2/sigma(1)**2)/sigma(1)/sqrt(pi2_dp)
    qc(:)=q(:,2)-center(2)
    lhkl=lhkl*exp(-0.5_dp*qc**2/sigma(2)**2)/sigma(2)/sqrt(pi2_dp)
    qc(:)=q(:,3)-center(3)
    lhkl=lhkl*exp(-0.5_dp*qc**2/sigma(3)**2)/sigma(3)/sqrt(pi2_dp)

end function lhklgauss

function sumlhklgauss(q,centers,sigma,f2,ncpu) result(sumlhkl)
    ! calculates intensities of normalized Gaussian peak in 3 dimensions with width sigma located at center
    ! for given 3D q values
    ! q should be >0

    ! wavevectors Nx3, center and width of peak in each dimension, f2 multiplicity of a peak
    real(dp), intent(in) :: q(:,:), centers(:,:), sigma(3), f2(:)
    ! number of cores (negative = not used cores)
    integer, intent(in)     :: ncpu
    ! center shifted q_i, result array
    real(dp)             :: sumlhkl(size(q,1)), temp(size(q,1))
    integer                 :: i

    call setncpu(ncpu)

    sumlhkl=0

    !$omp parallel do private(temp)
    do i=1,size(centers,1)
        temp = f2(i)*lhklgauss(q,centers(i,:),sigma)
        !$omp critical
        sumlhkl=sumlhkl + temp
        !$omp end critical
    end do
    !$omp end parallel do

end function sumlhklgauss

function outer(a,b) result(out)
    ! outer product
    real(dp), intent(in)    :: a(:),b(:)
    real(dp)                :: out(size(a,1), size(b,1))

    out = 0._dp
    out = spread(a,dim=2,ncopies=size(b)) * spread(b,dim=1,ncopies= size(a))

end function outer

function rotationmatrix(vector,angle) result(rotmat)
    ! get rotation matrix for rotation around vector by angle
    ! see https://en.wikipedia.org/wiki/Rotation_matrix#Rotation_matrix_from_axis_and_angle

    ! 3d rotation axis, rotation angle in rad
    real(dp), intent(in)    :: vector(3), angle
    ! output rotationmatrix
    real(dp)                :: rotmat(3,3)

    real(dp)                :: n(3) = 0._dp, nn(3,3)= 0._dp, skew(3,3) = 0._dp
    real(dp)                :: eye(3,3)=reshape( (/1._dp, 0._dp, 0._dp,  &
                                                   0._dp, 1._dp, 0._dp,  &
                                                   0._dp, 0._dp, 1._dp/), (/3, 3/) )

    rotmat = 0._dp
    n = vector /sqrt(sum(vector**2))
    nn = outer(n, n)
    skew(2,1) =  n(3)
    skew(3,1) = -n(2)
    skew(1,2) = -n(3)
    skew(3,2) =  n(1)
    skew(1,3) =  n(2)
    skew(2,3) = -n(1)
    rotmat = cos(angle) * eye + sin(angle) * skew + (1-cos(angle)) * nn

end function rotationmatrix

function rotatearoundvector(r,vector,angle) result(rotr)
    ! rotate vectors r around vector by angle

    ! points 3xN, 3d rotation axis, rotation angle in rad
    real(dp), intent(in)    :: r(:,:), vector(3), angle
    ! rotated r
    real(dp)                :: rotr(size(r,1),size(r,2)), rotmat(3,3)

    rotr = 0._dp
    rotmat = 0._dp
    rotmat = rotationmatrix(vector,angle)
    rotr = matmul(rotmat,r)

end function rotatearoundvector

function eulerrotationmatrix(axes, psi, phi, theta)  result(rotmat)
    ! rotation matrix from 3 rotations around extrinsic axes with euler angles
    ! axes defines order of rotations with 1=x, 2=y,3=z
    ! R=R(axes(3))*R(axes(2))*R(axes(1))

    ! axes order
    integer, intent(in)     :: axes(3)
    !angles
    real(dp), intent(in)    :: psi, phi, theta
    ! output rotationmatrix
    real(dp)                :: rotmat(3,3), v1(3), v2(3), v3(3)

    rotmat = 0._dp
    v1 = 0._dp
    v2 = 0._dp
    v3 = 0._dp
    v3(axes(3)) = 1._dp
    v2(axes(2)) = 1._dp
    v1(axes(1)) = 1._dp
    rotmat = matmul(rotationmatrix(v3, theta) ,matmul(rotationmatrix(v2, phi), rotationmatrix(v1, psi)))

end function eulerrotationmatrix

end module utils

!    -*- f90 -*-
! -*- coding: utf-8 -*-
! faddeevas taken from https://github.com/aoeftiger/faddeevas
!
! Collection of FADDEEVA Implementations
! Please refer to the review published on the IPAC 2016:
! http://accelconf.web.cern.ch/AccelConf/ipac2016/papers/wepoy044.pdf
!
! This is taken from cernlib-f90: cernlib as in madx, sixtrack, ptc, pyheadtail
! aoeftiger/faddeevas is licensed under the GNU Lesser General Public License v2.1

  subroutine ccperrfr(xx, yy, wx, wy)
    implicit none
    !----------------------------------------------------------------------*
    ! purpose:                                                             *
    !   modification of wwerf, double precision complex error function,    *
    !   written at cern by K. Koelbig.                                     *
    ! input:                                                               *
    !   xx, yy    (double)    real + imag argument                         *
    ! output:                                                              *
    !   wx, wy    (double)    real + imag function result                  *
    !----------------------------------------------------------------------*
    integer n,nc,nu
    real(8), INTENT(IN):: xx,yy
    real(8), INTENT(OUT):: wx,wy
    real(8) x,y,q,h,xl,xh,yh,tx,ty,tn,sx,sy,saux, rx(33),ry(33)
    real(8), parameter :: cc=1.12837916709551D0,xlim=5.33D0,ylim=4.29D0,fac1=3.2D0,fac2=23,fac3=21

    x = abs(xx)
    y = abs(yy)

    if (y < ylim  .and.  x < xlim) then
       q  = (1.0D0 - y / ylim) * sqrt(1.0D0 - (x/xlim)**2)
       h  = 1.0D0 / (fac1 * q)
       nc = 7 + int(fac2*q)
       xl = h**(1 - nc)
       xh = y + 0.5/h
       yh = x
       nu = 10 + int(fac3*q)
       rx(nu+1) = 0.0
       ry(nu+1) = 0.0

       do n = nu, 1, -1
          tx = xh + n * rx(n+1)
          ty = yh - n * ry(n+1)
          tn = tx*tx + ty*ty
          rx(n) = 0.5D0 * tx / tn
          ry(n) = 0.5D0 * ty / tn
       enddo

       sx = 0.0
       sy = 0.0

       do n = nc, 1, -1
          saux = sx + xl
          sx = rx(n) * saux - ry(n) * sy
          sy = rx(n) * sy + ry(n) * saux
          xl = h * xl
       enddo

       wx = cc * sx
       wy = cc * sy
    else
       xh = y
       yh = x
       rx(1) = 0.0
       ry(1) = 0.0

       do n = 9, 1, -1
          tx = xh + n * rx(1)
          ty = yh - n * ry(1)
          tn = tx*tx + ty*ty
          rx(1) = 0.5D0 * tx / tn
          ry(1) = 0.5D0 * ty / tn
       enddo

       wx = cc * rx(1)
       wy = cc * ry(1)
    endif

    !      if(y .eq. zero) wx = exp(-x**2)
    if(yy < 0.0) then
       wx =   2.0D0 * exp(y*y-x*x) * cos(2.0D0*x*y) - wx
       wy = - 2.0D0 * exp(y*y-x*x) * sin(2.0D0*x*y) - wy
       if(xx > 0.0) wy = -wy
    else
       if(xx < 0.0) wy = -wy
    endif

  end SUBROUTINE ccperrfr
